/* Kryptenzellen auf starrem Substrat */
/* mit  veraenderter Netzstruktur */
//simplified Variante

#include <math.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <limits.h>
#include <float.h>

#include "deklarationen.h"
#include "vars.h"

#define SGN(x) ((x)==0?0:((x)>0?1:-1))

#define BAUM

#define MELDUNGEN

/* Felder */
typedef double matrixZ[ZSIZE][ZFELDER];
typedef double matrixP[PSIZE][10];

typedef double matrixW[ZSIZE][6];
typedef int    matrixN; //to be deleted

typedef double  matrixAZ[ZSIZE][MAX_NEIGHB][7];	//NOTE: add uid and lineage
typedef double  matrixAP[PSIZE][PPZ];

typedef double  feldW[1551][6];


typedef int        feldA[6];
typedef double     feldT[4];
typedef long       feldZ[1];

typedef double vector[3];

typedef int markf[700][MAXMARK];    

typedef struct
  {
    double t;
    int status;
    int imark;
  } TMesspunkt;

typedef TMesspunkt TFM[MPZ];

/*normal and uniform distributed random numbers, planed to use for PB's mutation step determination*/
const double DBL_EPS_COMP = 1 - DBL_EPSILON; // DBL_EPSILON is defined in <float.h>.
inline double RandU() {
    return DBL_EPSILON + ((double) rand()/RAND_MAX);
}
inline double RandN2(double mu, double sigma) {
    return mu + (rand()%2 ? -1.0 : 1.0)*sigma*pow(-log(DBL_EPS_COMP*RandU()), 0.5);
}
inline double RandN() {
    return RandN2(0, 1.0);
}

/*Z-Zelle*/

/* Prozeduren Initialisierung */
int mynetz(matrixZ NetzFeld,matrixAZ VerbFeld);
void belegP();

/* Prozeduren Programm */
void develP();

/* Unterprozeduren Programm*/
void transP();
void radiusP();
void statusZP();
void statusPP();

/* Hilfsprozeduren */
void proliferation();
//void mitoseZ();
void mitoseP();
void apoptoseP();

/* Funktionen */
void fZwzz();
void fRwzz();

void fSzp();

void makering(double hoehe, int n, matrixZ CZ,feldA N);
void printNetz(matrixZ NetzFeld, matrixAZ VerbFeld);
void printWWP(matrixP WWP,feldA M);
void printPool(const char* filename,const char* color,int pool[ZSIZE],int bis,matrixZ CZ);
void eliminate(matrixZ CZ, int HZ,feldA N,feldT T,matrixW BW);
void markiereS(matrixZ CZ, feldT T,feldA N);
void printCells(const int nr,matrixZ CZ,feldA N);
double messpunkt(matrixZ CZ,feldT T,feldA N);
void schnitt(const char* filename, matrixZ CZ, feldA N,feldT T,int nm);
void brduCells(const int ai,const int nr1,const int nr2,matrixZ CZ,feldA N,feldT T);
#if (MUTATE!=MUT_OFF) 
  void mutate_fixed(matrixZ CZ,int HZ);
#endif //!MUTATE
/*these methods are independent of the mutation type and necessary in any case*/
void get_lineage_mutate_property(matrixZ CZ, int HZ);
double get_lineage_initial_property(int i, int lin);

/* Variablen */
long       DM,DN;
double halbzeit,TauD;	
int grenze;
long polymere=0;
int versuch;
int nmark;
markf mf;
long nextind=6;
int ko=0;

FILE *fp_res;

int echt=0;
int q=0;

double get_lineage_initial_property(int i, int lin) {
  return mut_params[i][2][lin]; //initial value
}

void feldout(matrixZ feld,int zaehler)
{
  int i;
  FILE *res;
  res=fopen("feldout","w");  
  for (i=0; i<zaehler; i++) 
    { 
      fprintf (res,"sphere {<%f,%f,%f>,1 pigment {Green}}\n",feld[i][0],feld[i][1],feld[i][2]);
    }
  fclose(res);
};

      
double zufall(double von,double bis)
{
  if (bis<von) {
    double tmp=von;
    von=bis;
    bis=tmp;
  }
  return ((rand()/(double)RAND_MAX)*(bis-von)+von);
};


double abstand(int a,int b,matrixZ PunktFeld)
{
  int i;
  double d=0;
  for(i=0;i<3;i++)
      {
	d+=(PunktFeld[a][i]-PunktFeld[b][i])*(PunktFeld[a][i]-PunktFeld[b][i]);
      };
  d=sqrt(d);
  return d;
};



/* Grundprogramm*/

int main()
{
  int i,j,k,HZ;

  matrixZ    CZ={0},sCZ;       /* Koordinaten   Zellen */
  matrixZ    FZges={0};    /* Kraefte        Zellen */
  
  matrixW    BW={0};       /* Bindungswerte Zellen - Boden  */
  matrixAZ   BN={0};       /* Nachbarwerte  Zellen - Zellen */
  
  matrixP    CP={0},sCP;       /* Koordinaten   Polymere */
  matrixP    FPges={0};    /* Kraefte        Polymere */
    
  matrixAP    BM={0};       /* Nachbarwerte  Polymere - Zellen */
  matrixN     BP={0};       /* Netzverbindungen */
  
 
  feldW    Histo={0}, Zyklus={0}, HZyklus={0};
  
  feldA    N={0},sN;   /* Zellzahl         */
  feldA    M={0},sM;   /* Polymerzahl      */
  feldT    T={0},sT;   /* Systemzeit       */
  feldZ    Z={0};   /* Zufallsgenerator */
 
  /*vars.h*/
  init_mut_params();

  /* Zufallsgenerator */
  Z[0]=2;
  
  
  //Initialisierung des Zufallsgenerators
  unsigned int seed;
#ifdef SRAND
  seed=SRAND;
#else
  seed=(unsigned int) time((time_t *)NULL);
#endif
  printf("seed=%i\n",seed);
  srand(seed);
  

  printf("WZad=%f\n",WZad);
  printf("etaS=%f,etaP=%f,etaN=%f,eta0=%f,etaV=%f\n",etaS,etaP,etaN,eta0,etaV);
  printf("Wprol=%f,Wdif=%f,RC=%f\n",Wprol,Wdif,RC);
  printf("ZTiefe=%f,DS=%f,LS=%f\n",ZTiefe,dDS,LS);
  
  printf("Kelast=%f,Delast=%f,Toleranz=%f\n\n",Kelast,Delast,Toleranz);

#ifdef PAN_Lifetime
  printf("PAN_Lifetime=%f\n",PAN_Lifetime);
#endif
#ifdef PAN_APOPTOSE_NO_NEIGH_WITH_NOTCH_RECEPTOR
  printf("PAN Apoptose if no SC Neighbour=%f\n",PAN_APOPTOSE_NO_NEIGH_WITH_NOTCH_RECEPTOR*ZEITNORM);
#endif

  printf("CWB=%f,CWB_PAN=%f\n",CWB,CWB_PAN);

  printf("WinkelSchritte:%f,BasisSchritte:%f,ZSchritte:%f\n",WinkelSchritte,BasisSchritte,ZSchritte);

  printf("Modus:");
#ifdef BAUM
  printf("BAUM\n");
#endif

  printf("Intervention:");
#ifdef WNT_HIGH
  printf("WNT_HIGH");
#endif
#ifdef WNT_LOW
  printf("WNT_LOW");
#endif 
#ifdef NOTCH_HIGH
  printf("NOTCH_HIGH");
#endif 
#ifdef NOTCH_LOW 
  printf("NOTCH_LOW");
#endif 
printf("\n");
#ifdef SRAND
  printf("SRAND %i\n",SRAND);
#endif
#if (MUTATE!=MUT_OFF)
  printf("MUTATE: %i STEP: %i ",MUTATE, MUT_STEP);
#  ifdef MUT_LINEAGE
    printf("MUT_LINEAGE %i ",MUT_LINEAGE);
#  endif
  printf("MUTATE starts at T:%f",T_MUT);
  printf("\n");
#endif //MUTATE!=MUT_OFF
  /* Konfiguration Netz */
  grenze=mynetz(CZ,BN);
  printf("Netz konstruiert mit %d Punkten und %d Polymeren\n",grenze,polymere);
  printNetz(CZ,BN);
  /* Einsatz der Polymere */
  belegP(CP,CZ,BW,BP,BN,BM,N,M,T,Z);
  printWWP(CP,M);
  /* Einsatz Zellen */
  makering(ZTiefe+2,5,CZ,N);
  statusZP(CP,CZ,BW,BN,BM,N,M,T);
  printf("Zellen eingesetzt\n");
  //printf("CZ[0][3]:%f\n",CZ[0][3]);
  T[0]=0.0; 

  //NOTE: create output files, parametrize this
  fclose(fopen("Mwer","w+"));
  fclose(fopen("CooT","w+"));
  
//  Lsys=Lsys+Lflat;
  /* Modellierung */
  /* Entwicklung des P-Systems */
  develP(CP,FPges,CZ,FZges,BW,BP,BN,BM,Histo,Zyklus,HZyklus,N,M,T,Z);
  printf("Nach develP im Hauptprogramm\n");
	return 0;
};



void printNetz(matrixZ PunktFeld,matrixAZ VerbFeld)
{
  FILE *dat;
  int HZ,HN,j,k;
  dat=fopen("Netz.pov","w");
  for(HZ=0;HZ<grenze;HZ++)
    {
      k=(int)PunktFeld[HZ][10]; //fuer alle von diesem Punkt ausgehenden Verbindungen
      for (j=0; j<k; j++) 
	{ 
	  HN=(int)VerbFeld[HZ][j][0];
	  fprintf(dat,"cylinder {<%f,%f,%f>,",PunktFeld[HZ][0],PunktFeld[HZ][1],PunktFeld[HZ][2]);
	  fprintf(dat,"<%f,%f,%f>",PunktFeld[HN][0],PunktFeld[HN][1],PunktFeld[HN][2]);
	  fprintf(dat,",0.05 pigment {Red}}\n");
	};
    };
  fclose(dat);
};

void printWWP(matrixP WWP,feldA M)
{
  int i;
  FILE *fp_res;
  fp_res=fopen("WWP.pov","w");
  for (i=0; i<M[0]; i++) //fuer alle WW-Punkte
    {
	 fprintf(fp_res,"sphere {<%f,%f,%f>,0.12 pigment {Black} }\n",WWP[i][0],WWP[i][1],WWP[i][2]);
    }
  fprintf(fp_res,"\n"); 
  fclose(fp_res);
  
};


int mynetz(matrixZ PunktFeld,matrixAZ VerbFeld)
{
  double x,y,z,zreg; //Zwischenspeicherung der Koordinaten
  double d,dreg; //Abstand von z-Achse
  double phi,phireg; //Winkel beim Zeichnen der Kreise
  int zaehler=0,backup;
  int i,j,von=0,nach=0;
  int neben,unten,schraeg_unten;

  double BasisGrenze; //Abstand, bis zu dem in z=0 Ebene ein Netz gezeichet wird
  double zmin;

  void verbinde(int von,int nach)
  {
    int k; //Anzahl der Verbindungen, die von "von" ausgehen
    k=(int)PunktFeld[von][10];
    if (abstand(von,nach,PunktFeld)==0) 
      {
	//printf("Abstand 0 fuer:%d-%d,k=%d\n",von,nach,k);
	return;
      };
    polymere++;
    VerbFeld[von][k][0]=nach;
    VerbFeld[von][k][1]=abstand(von,nach,PunktFeld);
    PunktFeld[von][10]=k+1;
  };
  
  double inkreisradius(int A,int B,int C)
  {
    int i;
    double la=0,lb=0,lc=0,gamma,r; //Seitenlaengen, winkel, Radius
    
    la=abstand(B,C,PunktFeld);lb=abstand(A,C,PunktFeld);lc=abstand(B,A,PunktFeld);
    if ((la==0) || (lb==0) || (lc==0)) return 0;
    
    gamma=acos((la*la+lb*lb-lc*lc)/(2*la*lb));
    r=(la+lb-lc)/2*tan(gamma/2.0);
    return r;
  };

  int erzeugeMittelpunkt(int A,int B,int C)
  {
    double la,lb,lc; //Seitenlaengen
    double bx,by,bz,cx,cy; //Komponenten der Richtungsvektoren der Winkelhalbierenden
    double t; //Laufvariable in Geradengleichung der Gerade b
    double x,y,z;
    
    la=abstand(B,C,PunktFeld);lb=abstand(A,C,PunktFeld);lc=abstand(A,B,PunktFeld);
    if ((la==0) || (lb==0) || (lc==0)) 
      printf("erzeugeMittelpunkt wurde fuer ein Dreieck mit nicht vorhandener Seite aufgerufen");

    //Richtungsvektor fuer die Winkelhalbierende von gamma
    cx=(PunktFeld[B][0]-PunktFeld[C][0])/la+(PunktFeld[A][0]-PunktFeld[C][0])/lb;
    cy=(PunktFeld[B][1]-PunktFeld[C][1])/la+(PunktFeld[A][1]-PunktFeld[C][1])/lb;
    //printf("cx:%f,cy:%f\n",cx,cy);
    
    //Richtungvektor fuer die Winkelhalbierende von beta
    bx=(PunktFeld[C][0]-PunktFeld[B][0])/la+(PunktFeld[A][0]-PunktFeld[B][0])/lc;
    by=(PunktFeld[C][1]-PunktFeld[B][1])/la+(PunktFeld[A][1]-PunktFeld[B][1])/lc;
    bz=(PunktFeld[C][2]-PunktFeld[B][2])/la+(PunktFeld[A][2]-PunktFeld[B][2])/lc;
    //printf("bx:%f,by:%f,bz:%f\n",bx,by,bz);
    
    //Loesung des LGS mit der Cramerschen Regel
    //der Inkreismittelpunkt ist der Schnittpunkt zweier Winkelhalbierender
    t=((PunktFeld[C][1]-PunktFeld[B][1])*cx-(PunktFeld[C][0]-PunktFeld[B][0])*cy)/((by*cx)-(bx*cy));
    x=PunktFeld[B][0]+t*bx;y=PunktFeld[B][1]+t*by;z=PunktFeld[B][2]+t*bz;
    //printf("t:%f\n",t);
    
    zaehler++;
    if (zaehler>ZSIZE) printf("error:zuviele Punkte beim Hinzufuegen;%d",zaehler);
    PunktFeld[zaehler][0]=x;PunktFeld[zaehler][1]=y;
    PunktFeld[zaehler][2]=z;
    PunktFeld[zaehler][10]=0;
    //printf("erzeuge Mittelpunkt\n");
    return zaehler;
  };
  
  void behandleDreieck(int A,int B,int C)
  {
    double r;
    int k;
    r=inkreisradius(A,B,C);
    //printf("r:%f\n",r);
    if (r<RADIUS_LIMIT) return;
    //printf("A:%d,B:%d,C:%d,AB:%f,AC:%f,BC:%fr:%f\n",A,B,C,abstand(A,B),abstand(A,C),abstand(B,C),r);
    
    k=erzeugeMittelpunkt(A,B,C);
    verbinde(k,A);verbinde(k,B);verbinde(k,C);
    behandleDreieck(A,B,k);behandleDreieck(A,C,k);behandleDreieck(B,C,k);
  };
  

  
  //Konstruktion der Netzpunkte mit z=0;
  BasisGrenze=sqrt((1+tan(M_PI/WinkelSchritte)*tan(M_PI/WinkelSchritte))*(Lsys+Lflat)*(Lsys+Lflat));
  //BasisGrenze=(Lsys+Lflat)*M_SQRT2;
  printf("BasisGrenze:%f\n",BasisGrenze);
  
  for(dreg=BasisGrenze;dreg>Lsys+1E-8;dreg-=(BasisGrenze-Lsys)/BasisSchritte)
    {
      //printf("dreg:%f\n",dreg);
      for(phireg=0;phireg<2*M_PI-1e-8;phireg+=(2*M_PI/WinkelSchritte))
	{
	  //printf("phireg:%f\n",phireg/M_PI*180);
	  d=dreg+zufall(-BasisWackel,BasisWackel);
	  if (d<Lsys) d=Lsys;
	  
	  phi=phireg+zufall(-PhiWackel,PhiWackel);
	  if (phi>2*M_PI) phi=2*M_PI;
	  if (phi<0) phi=0;
	  
	  PunktFeld[zaehler][2]=0;
	  PunktFeld[zaehler][0]=d*cos(phi);
	  PunktFeld[zaehler][1]=d*sin(phi);
	  //printf("Punkt oben:<%f,%f,%f>\n",PunktFeld[zaehler][0],PunktFeld[zaehler][1],PunktFeld[zaehler][2]);
	  
	  zaehler++;
	};
      //printf("naechste Reihe --------------------\n");
    };

 
  //  printf("Zaehler nach z=0 Ebene:%d\n",zaehler);

  //Die Krypte ist drehsymmetrisch
  //Fuer jede Z-Koordinate wird der Abstand zur z-Achse berechnet
  //dann werden die Einzelpunkte als Punkte eines Kreise mit diesem Radius berechnet

  printf("ZTiefe:%f,Lsys:%f\n",ZTiefe,Lsys);
  //double tst=ZTiefe/ZSchritte;
  //printf("ZTiefe/ZSchritte:%f\n",tst);
  //Konstruktion der Netzpunkte
  
  for(zreg=0;zreg>ZTiefe+(1E-5);zreg+=(ZTiefe/ZSchritte)) //Ebenen, in denen Netzpunkte liegen ausser die letzten beiden
    {
      //printf("zreg:%f\n",zreg);
      for(phireg=0;phireg<2*M_PI-1e-8;phireg+=(2*M_PI/WinkelSchritte)) //Zeichnen der Punkte des n-Ecks
	//for(phireg=0;phireg<M_PI_2;phireg+=(2*M_PI/WinkelSchritte))	//Test um mit urspr. Netz zu vergleichen
	{           
	  phi=phireg;
	  //printf("phireg:%f\n",phireg/M_PI*180);
	  z=zreg+zufall(-ZWackel,ZWackel);
	  //if (z!=zreg) printf("komisch\n");
	  if (z<ZTiefe) z=ZTiefe;
	  if (z>0) z=0;

	  phi=phireg+zufall(-PhiWackel,PhiWackel);
	  if (phi>2*M_PI) 
	    { 
	      phi=2*M_PI;
	      //printf("phi-range<\n");
	    };
	  if (phi<0) 
	    {
	      phi=0;      //printf("dreg:%f\n",dreg)
	      //printf("phi-range>\n");
	    };
	
	  //d=M_2_PI*acos(pow((-z/ZTiefe),Steilheit)); //Berechnung des Radius des Kreises auf der entspr. Ebene
	  //d=sqrt(d)*Lsys; //muss wegen der Verwackelung jeweils neu berechnet werden
	  //d=d*(1.0+0.25*cos(-z*2*M_PI/ZTiefe+M_PI_2));
   
	  d=M_2_PI*acos(pow((z/ZTiefe),Steilheit)); //Berechnung des Radius des Kreises auf der entspr. Ebene
	  d=sqrt(d)*Lsys; //muss wegen der Verwackelung jeweils neu berechnet werden
	  d*=(1.0+lambda1*cos(z*2*M_PI/ZTiefe+M_PI_2));	  

	  x=d*cos(phi);
	  y=d*sin(phi);
      	  
	  //if (fabs(z+28.5)<1e-8) printf("<%f,%f,%f>\n",x,y,z);
	  PunktFeld[zaehler][0]=x;
	  PunktFeld[zaehler][1]=y;
	  PunktFeld[zaehler][2]=z;

	  zaehler++;
	  if (zaehler>ZSIZE-1) printf("error:Zuviele Punkte\n");
	};
      
    };
  //printf("Zaehler nach letzter Ebene:%d\n",zaehler);
  
  PunktFeld[zaehler][0]=0;PunktFeld[zaehler][1]=0;PunktFeld[zaehler][2]=ZTiefe; //in dieser Ebene fallen alle Punkte zusammen
 
  //Anzahl der ausgehenden Verbindungen fuer jeden Punkt auf 0 setzen
  for(i=0;i<=zaehler;i++) {PunktFeld[i][10]=0;}
 
  //printf("Zaehler nach Krypte:%d\n",zaehler);  

  //Konstruktion des Netzes
  von=0;
  for(i=0;i<ZSchritte+BasisSchritte-1;i++)
    {
      for(j=0;j<WinkelSchritte;j++)
	{
	  //Punkt eine Reihe weiter unten
	  unten=von+WinkelSchritte;;
	  verbinde(von,unten);
	  //if (von==unten)  printf("von==unten\n");

	  //in der z=k Ebene benachbarter Punkt
	  neben=von+1;
	  if (j==WinkelSchritte-1) neben-=WinkelSchritte;
	  verbinde(von,neben);
	  //if (von==neben) printf("von==neben\n");
	  
	  //Punkt schraeg unten
	  schraeg_unten=von+WinkelSchritte+1;
	  if (j==WinkelSchritte-1) schraeg_unten-=WinkelSchritte;
	  verbinde(von,schraeg_unten);	  
	  //if (von==schraeg_unten) printf("von==schraeg_unten");
	  
	  von++;
	};
    };				

 
  //feldout(PunktFeld,zaehler+1);
  //printf("verlasse mynetz vorzeitig\n");
  //return (zaehler+1);
  

  von=zaehler-WinkelSchritte;
  backup=zaehler;
  for(j=0;j<WinkelSchritte;j++)
    {   
      nach=zaehler; //=(ZSchritte+BasisSchritte+1)*WinkelSchritte
      verbinde(von,nach);	  
      //printf("verbinde oben:<%f,%f,%f>-<%f,%f,%f>\n",PunktFeld[von][0],PunktFeld[von][1],PunktFeld[von][2],PunktFeld[nach][0],PunktFeld[nach][1],PunktFeld[nach][2]);
      nach=von+1;
      if (j==WinkelSchritte-1) nach-=WinkelSchritte;
      verbinde(von,nach);	  
      //printf("verbinde unten:<%f,%f,%f>-<%f,%f,%f>\n",PunktFeld[von][0],PunktFeld[von][1],PunktFeld[von][2],PunktFeld[nach][0],PunktFeld[nach][1],PunktFeld[nach][2]);
      von++;
    };
  printf("Benoetigte Punkte vor Test des Inkreisradius:%d\n",zaehler+1);
  //feldout(PunktFeld,zaehler+1);
  //printf("verlasse mynetz vorzeitig\n");
  //return (zaehler+1);

  //Ueberpruefen der Dreiecke des oberen Teils der Krypte
  von=0;
  for(i=0;i<ZSchritte+BasisSchritte-1;i++)
    {
      for(j=0;j<WinkelSchritte;j++)
	{
	  //Punkt eine Reihe weiter unten
	  unten=von+WinkelSchritte;;
	  
	  //in der z=k Ebene benachbarter Punkt
	  neben=von+1;
	  if (j==WinkelSchritte-1) neben-=WinkelSchritte;
	  	  
	  //Punkt schraeg unten
	  schraeg_unten=von+WinkelSchritte+1;
	  if (j==WinkelSchritte-1) schraeg_unten-=WinkelSchritte;
	  behandleDreieck(von,unten,schraeg_unten);
	  behandleDreieck(von,neben,schraeg_unten);
	  von++;
	};
    };				
 
  //printf("Ende oben mit ueberpruefen bei:%d\n",von-1);
  //printf("verlasse mynetz vorzeitig\n");
  //feldout(PunktFeld,zaehler+1);
  //return (zaehler+1);
  
   //Ueberpruefen der Dreiecke des letzen n-Ecks
  // von=(ZSchritte+BasisSchritte-1)*WinkelSchritte;
  //printf("zaehler:%d\n",zaehler);
  //printf("von:%d\n",von);
  von=backup-WinkelSchritte;
  //printf("Beginne unten mit Ueberpruefen bei:%d\n",von);
    for(j=0;j<WinkelSchritte;j++)
    {   
      //unten=(ZSchritte+BasisSchritte)*WinkelSchritte;
      unten=backup;
      //printf("Punkt unten beim uberpruefen:<%f,%f,%f>\n",PunktFeld[unten][0],PunktFeld[unten][1],PunktFeld[unten][2]);
      neben=von+1;
      if (j==WinkelSchritte-1) neben-=WinkelSchritte;
      behandleDreieck(von,unten,neben);	  
      //printf("Ueberpruefe unten Dreieck:<%f,%f,%f>,<%f,%f,%f>,<%f,%f,%f>\n",PunktFeld[von][0],PunktFeld[von][1],PunktFeld[von][2],PunktFeld[unten][0],PunktFeld[unten][1],PunktFeld[unten][2],PunktFeld[neben][0],PunktFeld[neben][1],PunktFeld[neben][2]);
	  
      von++;
    };
  
  //feldout(PunktFeld,zaehler+1);
  // printf("Benoetigte Punkte insgesamt:%d\n",zaehler+1);
    return(zaehler+1);
};



////






/* Belegung mit Polymeren */
void belegP(CP,CZ,BW,BP,BN,BM,N,M,T,Z)
matrixP    CP;
matrixZ    CZ;
matrixW    BW;
matrixN    BP;
matrixAZ   BN;
matrixAP   BM;
feldA      N,M;
feldT      T;
feldZ      Z;

{   
  int i,ii,j,jj,k,l,ll,HZ,HZZ,HN,HP,HPP,needed_segments;
  double d,zuz;
  double length;

  /* CP[HZ][j][0]       x-Koordinate   */
  /* CP[HZ][j][1]       y-Koordinate   */
  /* CP[HZ][j][2]       z-Koordinate   */
  /* CP[HZ][j][3]       Zellverbindung Wert */
  /* CP[HZ][j][4]       Zellverbindung Nr.  */
  /* CP[HZ][j][5]       Netzverbindung Wert   */
  /* CP[HZ][j][6]       Netzverbindung Anzahl */
  
  /* CP[HZ][0][7]       Polymerlaenge soll */
  /* CP[HZ][0][8]       Polymerlaenge ist  */
  /* CP[HZ][j][7]       Segmentlaenge ist  */
  /* CP[HZ][j][8]       Segmentwinkel */
  /* CP[HZ][j][9]       Abstand             */
  
  /* BW[0][0]           Polymer-Kontakt */
  /* BW[0][1]           x-Koordinate  der Orientierung */
  /* BW[0][2]           y-Koordinate   */
  /* BW[0][3]           z-Koordinate   */
  /* BW[0][4]           Anzahl der PolymerKontakte */
  
  /* BM[0][x][0]        Nachbar x Nummer,  x von 0- CZ[0][5]    */
  /* BM[0][x][1]        Segement NR.                            */
  
  
  void setze(double x,double y,double z)
  {
    //if ((fabs(x)<=(Lsys+Lflat)) && (fabs(y)<=(Lsys+Lflat)))
      {
	CP[HP][0]=x;CP[HP][1]=y;CP[HP][2]=z;
	HP++;
	if (HP>PSIZE-1) printf("Array fuer WWP reicht nicht aus\n");
      };
  };
  
  HP=0;
  for(HZ=grenze-1;HZ>=0;HZ--) //Fuer alle Netzpunkte
    {
      //Punkt selbst setzen
      setze(CZ[HZ][0],CZ[HZ][1],CZ[HZ][2]);
      
      k=(int)CZ[HZ][10]; //fuer alle von diesem Punkt ausgehenden Verbindungen
      for (j=0; j<k; j++) 
	{ 
	  HN=(int)BN[HZ][j][0];
	  length=BN[HZ][j][1]; //Abstand zwischen den Punkten
	  needed_segments=(int) (length/SEG_LENGTH)+1;
  
	  double nach[3],von[3];
	  
	  for (i=0; i<3; i++) {von[i]=CZ[HZ][i];} //Kopieren der Anfangskoordinaten des Polymers
	  for (i=0; i<3; i++) {nach[i]=CZ[HN][i];} //Kopieren der Endkoordinaten des Polymers
	    
	  //printf("Polymer von <%f,%f,%f,> nach <%f,%f,%f>\n",von[0],von[1],von[2],nach[0],nach[1],nach[2]);
	  //printf("Richtungsvektor: <%f,%f,%f>\n",nach[0]-von[0],nach[1]-von[1],nach[2]-von[2]);
	  //printf("needed_segments:%d\n",needed_segments);
	  for (ii=1; ii<needed_segments-1;ii++)  //Zerlegung in Segmente
	    {
	      setze(von[0]+(nach[0]-von[0])*((double) ii/(needed_segments-1)),von[1]+(nach[1]-von[1])*((double) ii/(needed_segments-1)), von[2]+(nach[2]-von[2])*((double) ii/(needed_segments-1)));
	    };
	  
	} /* Ende HZ-Schleife */
    }
  
  
  M[0]=HP;
  for(i=0;i<M[0];i++)
    {
      CP[i][5]=0;
    };
  
  /* statusZ1berechnung */
  statusPP(CP,CZ,BW,BN,N,M,Z);   /* Setzt L0 zB identisch der Mittleren Segmentlaenge oder eliminiere L0 */
  statusZP(CP,CZ,BW,BN,BM,N,M,T);
  printf("Polymere belegt mit %d WW-Punkten\n",HP);
  return;
};

void develP(CP,FPges,CZ,FZges,BW,BP,BN,BM,Histo,Zyklus,HZyklus,N,M,T,Z)
     matrixP          CP,FPges;
     matrixZ          CZ,FZges;
     matrixW          BW;
     matrixN          BP;
     matrixAZ         BN;
     matrixAP         BM;
     feldW            Histo,Zyklus,HZyklus;
     feldA               N,M;
     feldT               T;
     feldZ               Z;
{    
  int   i,j,k,HZ,HP,Ttest,mut_t_fixed_done;
  double TT,dt0,dt1,dt2,Zmax,Rmax,Dmin,zcomp,nwwp;
  double d,dr,dm;
  char Mwer[6]="Mwer";
  char Pwer[6]="Pwer";
  char CooT[6]="CooT";
  int ueber0,nschnitt;
  double zielt;
  int warm,zaehler;
  double bias;

  typedef double matF[ZSIZE][10];
  typedef double feldM[7] ;
  typedef double feldP[30][2];
  matF      FZalt={0};
  feldM     Mwert={0};
  feldP     Pwert={0};


  TT=0.0; T[1]=deltaT;zielt=VORLAUF1;
  T[0]=0.0;
  zielt=messpunkt(CZ,T,N);
  mut_t_fixed_done=0;

  //printf("am beginn von develP CZ[0][3]:%f\n",CZ[0][3]);
  printf("Tmax=%f\n",TMAX);
  while (T[0]<TMAX) 
    {  /* Gesamtzeit  */
      if (T[0]>3) echt=1;
#if (MUTATE!=MUT_OFF)
      if (!mut_t_fixed_done) {
        if (T[0]>T_MUT) {
#    if (MUTATE==MUT_T_FIXED_LOWEST)
	  int low_i=-1;
#    endif
	  printf("NOTE: mutate at fixed timepoint\n");
	  mut_t_fixed_done=1;
	  /*for each cell*/
          for (i=0;i<N[0];++i) {
#    if (MUTATE==MUT_T_FIXED)
/*mutate any relevant cell*/
		mutate_fixed(CZ,i);
		printf("NOTE: mutate cell:%i lin:%.0f uid:%.0f pos_z:%f\n",i,CZ[i][LINEAGE],CZ[i][UID],CZ[i][2]);
#    endif
#    if (MUTATE==MUT_T_FIXED_LOWEST)
/*identify the lowest cell */
#  ifdef MUT_LINEAGE
            /*lineage of cell must match*/
          if (CZ[i][LINEAGE]==MUT_LINEAGE)
#  endif //MUT_LINEAGE
{
	    if (low_i<0)
	      low_i=i;
	    else if (CZ[i][2]<CZ[low_i][2]) {
	      low_i=i;
	    }
	    }
#    endif //MUTATE==MUT_T_FIXED_LOWEST
	  }
#    if (MUTATE==MUT_T_FIXED_LOWEST)
	  if (low_i>-1) {
	    mutate_fixed(CZ,low_i);
	    printf("NOTE: mutate cell:%i lin:%.0f uid:%.0f pos_z:%f\n",low_i,CZ[low_i][LINEAGE],CZ[low_i][UID],CZ[low_i][2]);
	  }
	  else
	    printf("NOTE: There is no cell to mutate, low_i:%i\n",low_i);
#    endif //MUTATE==MUT_T_FIXED_LOWEST
	}
      }
#endif //MUTATE==MUT_T_FIXED
      
      if ((N[0]>1500) || (N[0]==0)) { T[0]=TMAX;printf("error:Abbruch N[0]=%d,M[0]=%d\n",N[0],M[0]);};
      
    
    /* Mittelwerte in definierten Zeitschritten */
    
       
    /* Wachstum */
      proliferation(CZ,BW,N,T,Z,BN); //Groesserwerden und Wechsel des Proliferationszustandes
    //printf("nach proliferation CZ[0][3]:%f\n",CZ[0][3]);

    // Berechnung des Abstandes der am naechsten liegenden Nachbarnzelle fuer alle Zellen
    for (HZ=0; HZ<N[0]; HZ++)  //Fuer alle Zellen
      {
	Dmin=deltaR; HP=(int)CZ[HZ][5]; //Anzahl der Nachbarn
	for (i=0; i<HP; i++)  //Fuer alle Nachbarn der Zelle
	  { 
	    if (BN[HZ][i][1]<Dmin) { Dmin=BN[HZ][i][1]; }
	  }
	FZalt[HZ][3]=Dmin/sqrt(3);
      }
 
    for (HZ=0; HZ<N[0]; HZ++)  //Fuer alle Zellen
      { 
	for (j=0; j<6; j++) 
	  { FZges[HZ][j]=0.0; }  
      }
    
 
    /* Berechnung der Kraefte auf Zellen */
    /* Translation */
    fZwzz(CZ,FZges,BN,N);
    //printf("nach  FZwww Fzges[0][3]=%f\n",FZges[0][3]);
    
    /* Radiuskorrektur */
    fRwzz(CZ,FZges,BN,N);
    //printf("nach fRwzz :Fzges[0][3]=%f\n",FZges[0][3]);
							

/*for (HZ=0; HZ<N[0]; HZ++)  //Fuer alle Zellen
{
   printf("after fRwzz: HZ:%i FZges:(%f,%f,%f)\n",HZ,FZges[HZ][0],FZges[HZ][1],FZges[HZ][2]);
}*/
    /* Berechnung der Kraftkopplung Polymere-Zellen */
    fSzp(CP,FPges,CZ,FZges,BW,M); //wird benoetigt
/*for (HZ=0; HZ<N[0]; HZ++)  //Fuer alle Zellen
{
  printf("after fSzp: HZ:%i FZges:(%f,%f,%f)\n",HZ,FZges[HZ][0],FZges[HZ][1],FZges[HZ][2]);
}*/
 
    for (HZ=0; HZ<N[0]; HZ++) { for (j=0; j<3; j++) { FZalt[HZ][j]=FZges[HZ][j]; }}
    //printf("vor trans:CZ[0][3]:%f\n",CZ[0][3]);
    //printf("vor trans Fzges[0][3]=%f\n",FZges[0][3]);
    Ttest=0; T[1]=deltaT;
    while (Ttest==0) 
      {
	/* Translation */
	transP(CP,FPges,CZ,FZges,BW,BN,BM,N,M,T,Z);
	//printf("nach trans: Fzges[0][3]=%f\n",FZges[0][3]);
     
	/* Schrittweitenbestimmung */
	dt1=deltaT;
	for (HZ=0; HZ<N[0]; HZ++) 
	  {
	    Zmax=10.0;
	    Rmax=0.0;
	    Rmax=FZges[HZ][5];
	    if (Rmax==0.0) 
	      { Rmax=1.0;}
	    dt0=FZalt[HZ][3]/(Zmax+Rmax)/2.0;
	    if (dt1>dt0)
	      { dt1=dt0; }
	  }
     
	if (dt1>=T[1]) 
	  { Ttest=1;  }
	else         
	  { 
	    T[1]=dt1;
	    printf("Zeitschrittveraenderung\n");	    
	    for (HZ=0; HZ<N[0]; HZ++) 
	      { 
		for (j=0; j<3; j++) 
		  { FZges[HZ][j]=FZalt[HZ][j]; }
		FZges[HZ][5]=0.0;
	      }
	  }
      }
 
    /* Radiuskorrektur*/
    //printf("vor radiusP  Fzges[0][3]=%f\n",FZges[0][3]);
    radiusP(CZ,FZges,BW,BN,BM,N,T,Z);
  
 
    T[2]=T[2]+1.0;
    T[0]=T[0]+T[1];  TT=TT+T[1];

    /* Neue Koordinaten Zellen */
    dm=0.0;
    //printf("vor schleife CZ[0][3]:%f\n",CZ[0][3]);
    for (HZ=0; HZ<N[0]; HZ++) 
      {
	dr=0.0;
	
	switch((int)CZ[HZ][LINEAGE])
	  {
	  case LIN_PAN: bias=PanBias;break;
	  case LIN_SC: bias=SBias;break;
	  default: bias=ABias;break;
	  };
	FZges[HZ][2]+=bias;
//printf("DEBUG POS: uid=%f,lineage=%f,fzges=f(%f,%f,%f)\n",CZ[HZ][UID],CZ[HZ][LINEAGE],FZges[HZ][0],FZges[HZ][1],FZges[HZ][2]);
	if (FZges[HZ][4]>0.0) 
	  { 
	    for (j=0; j<3; j++) 
	      {  
		if (isnan(d))
		  printf("error:d ist nan:HZ=%d,j=%d,FZges[HZ][j]=%f,FZges[HZ][4]=%f\n",HZ,j,FZges[HZ][j],FZges[HZ][4]);
		d=FZges[HZ][j]*T[1];
		CZ[HZ][j]=CZ[HZ][j]+d;
		dr=dr+d*d; 
	      } 
	  }
	
	CZ[HZ][3]=CZ[HZ][3]+FZges[HZ][3]*T[1];
	dr=sqrt(dr); if (dr>dm) { dm=dr; }
      }
    /* printf("Zmax= %f  ",dm); */

    
    /* Histogramme */
    if (T[0]>15.0) 
      {
	HZ=(int)(-25.0*log(T[1]/deltaT));
	if (HZ<500) { Histo[HZ][0]=Histo[HZ][0]+1.0e-6;}
      }
    
    /* statusZPberechnung */
    //printf("nach der Schleife CZ[0][3]:%f\n",CZ[0][3]);
    // printf("vor status in develP:N[0]:%d,CZ[0][3]:%f\n",N[0],CZ[0][3]);
    statusPP(CP,CZ,BW,BN,N,M,Z);
    statusZP(CP,CZ,BW,BN,BM,N,M,T);
 
    
    d=0.0;
    for (i=0; i<N[0]; i++) {   d=d+BW[i][0]*BW[i][4]/(double)N[0]; } //Durchschnittl. Kontaktstaerke Boden*Kontaktflaeche =Durchschnittl. Kraft
    
    //if (N[0]<10) { printf("T= %f dT= %f Nb= %f Nges= %d\n",T[0],T[1],d,N[0]); }
    
    
 
    /* Mitose */
    mitoseP(CP,CZ,BW,BN,BM,Zyklus,N,M,T,Z);
    //printf("nach mitose CZ[0][3]:%f\n",CZ[0][3]);
    /* Apoptose */
    apoptoseP(CP,CZ,BW,BN,BM,Zyklus,N,M,T,Z);
    //printf("nach apoptoseCZ[0][3]:%f\n",CZ[0][3]);

     
    if (TT>0.1) {
      
      //Mwert[0]=Anzahl der Zellen
      //Mwert[1]=Radius
      //Mwert[2]=Volumen ist
      //Mwert[3]=Anzahl Nachbarn
      //Mwert[4]=Volumen Soll
      //Mwert[5]=Anzahl in Apoptose gegangener Zellen
      //Mwert[6]=Anzahl im Cluster gestorbener Zellen

      ueber0=0;
      Mwert[0]=(double)N[0];
      zcomp=0;nwwp=0;
      for (j=1; j<7; j++) { Mwert[j]=0.0; }
      for (i=0; i<N[0]; i++) 
	{ 
	  for (j=1; j<5; j++) { Mwert[j]=Mwert[j]+CZ[i][j+2]; }
	  if (CZ[i][2]>0) ueber0++;
	  zcomp+=FZges[i][2]/FZges[i][4]*T[1];
	  nwwp+=BW[i][4];
	}
      zcomp=zcomp/(double) N[0];nwwp=nwwp/(double) N[0];
      for (j=1; j<5; j++) { Mwert[j]=Mwert[j]/Mwert[0]; }
      Mwert[5]=(double)N[1];
      Mwert[6]=(double)N[2];
      
      
      fp_res=fopen(Mwer,"a");
      fprintf(fp_res,"%f  ",T[0]);
      for (j=0; j<7; j++) { fprintf(fp_res,"%f  ",Mwert[j]);}
      fprintf(fp_res,"%d   ",ueber0);
      fprintf(fp_res,"%f   ",zcomp);
      fprintf(fp_res,"%f   ",nwwp);
      fprintf(fp_res,"\n");
      fclose(fp_res);
         
             
      if (T[0]>0.0) 
	{
	  
	  N[5]=N[5]+1; 
	  fp_res=fopen(CooT,"a");
	  //HP=0;
	  for (i=0; i<N[0]; i++)  //Fuer alle Zellen
	    {  
	    //  HZ=HP+(int)CZ[i][12];
	      HZ=(int)CZ[i][12];
	      fprintf(fp_res,"%d   %d   %.0f   ",N[5],i,CZ[i][LINEAGE]); 
	      for (j=0; j<4; j++) {    fprintf(fp_res,"%f   ",CZ[i][j]); } 
	      fprintf(fp_res,"%f   %f   %.0f   %.0f   %.0f",CZ[i][6]/V0-1.0,1.0-CZ[i][4]/CZ[i][6],CZ[i][UID],CZ[i][ANCESTOR],CZ[i][PROL_STAT]);

	      /*Mutation*/
	      for (j=0;j<NMUT;j++) {
	 	  double v;
#ifndef COOT_MUT_COUNTER
		  v=CZ[i][MUT_OFFSET+j];
		  if (j==MUT_CYCLETIME) v*=ZEITNORM;
#else
		  v=CZ[i][MUT_OFFSET+j+NMUT];
#endif //COOT_MUT_COUNTER
		  fprintf(fp_res,"   %f",v);
	      }
	      fprintf(fp_res,"\n");
	      //if ((int)(CZ[i][LINEAGE])==LIN_PAN)
	      //printf("paneth,position:%f %f %f\n",CZ[i][UID],CZ[i][2],T[0]);
	    }
	  fclose(fp_res);
	}
      T[2]=0.0;
      TT=0.0;
      fflush(stdout);
    }
   
    if (T[0]>=zielt)
    {
      zielt=messpunkt(CZ,T,N);
    }
   
    }  /* Ende Gesamtzeit */
  

  printf("Ende von develP\n");
  return;   
}

/* Unterprogramm zur Berechnung des Systemstatus Zellen */

void statusZP(CP,CZ,BW,BN,BM,N,M,T)
matrixP         CP;
matrixZ         CZ;
matrixW         BW;
matrixAZ        BN;
matrixAP        BM;
feldA           N,M;
feldT           T;

{ 
  int  i,j,k,HZ,HP,HN;
  double d,dr,dh,dy,dV,SA,dq;
     
  typedef int feldb[ZSIZE] ;
  feldb       bond={0};
  
  for (HZ=0; HZ<N[0]; HZ++) //Fuer alle Zellen
    {
      for (i=0; i<17; i++) 
	{ 
	  for (j=0; j<7; j++) { BN[HZ][i][j]=0.0; } //Alle Nachbarschaftswerte auf 0 setzen
      }
    }
  for (HZ=0; HZ<M[0]; HZ++) //Fuer alle WW-Punkte
    {
      BM[HZ][0]=0.0;  //Alle Bindungswerte Polymere-Zellen auf 0 setzen !!!
    }
  
 /* Volumen Setzung */
  for (HZ=0; HZ<N[0]; HZ++) { CZ[HZ][4]=V0*pow(CZ[HZ][3],3.0); } //V=4/3*pi*r³
  
  /* Haftungs-Ueberlappung Zellen */
  for (HZ=0; HZ<N[0]-1; HZ++) //Fuer alle Zellen
    {
      for (HP=HZ+1; HP<N[0]; HP++) //=>fuer alle Zellpaare (jeder gegen jeden)
       { 
	 dq=CZ[HZ][3]+CZ[HP][3]; //Quadrieren geht schneller als Wurzelziehen
	 dq=dq*dq;
	 d=CZ[HZ][2]-CZ[HP][2]; //Abstand in Z-Richtung
	 d=d*d;

	 if (d<=dq) //Abstand in Z-Richtung macht Ueberschneidung nicht unmoeglich
	   {
	     for (i=0; i<2; i++) 
	       { 
		 dr=CZ[HZ][i]-CZ[HP][i]; //Bestimmung des Abstandes der Zellen
		 d+=dr*dr;
	       };
	     if (d<=dq) //Wenn Abstand kleiner Summe der Radien=>Zellen beruehren sich
	       {  
		 d=sqrt(d);
		 BN[HZ][bond[HZ]][0]=(double)HP; //gegenseitiges Eintragen an naechste Stelle
		 BN[HP][bond[HP]][0]=(double)HZ;
		 BN[HZ][bond[HZ]][1]=d; //Eintragen des Abstandes
		 BN[HP][bond[HP]][1]=d;

		 //NOTE: UID and Lineage
                 BN[HZ][bond[HZ]][5]=CZ[HP][UID];
		 BN[HP][bond[HP]][5]=CZ[HZ][UID];
		 BN[HZ][bond[HZ]][6]=CZ[HP][LINEAGE];
		 BN[HP][bond[HP]][6]=CZ[HZ][LINEAGE];

	      
		 dr=(CZ[HZ][3]*CZ[HZ][3]-CZ[HP][3]*CZ[HP][3]); //Berechnen der Ueberlappung ???
		 dr=dr/2.0/d;
		 dy=CZ[HZ][3]-d/2-dr;
		 BN[HZ][bond[HZ]][2]=dy;
	      
		 dh=2.0*CZ[HZ][3]*dy-dy*dy; //Berechnen der Kontaktflaeche
		 BN[HZ][bond[HZ]][3]=Pi*dh;

		 dV=Pi/3.0*dy*dy*(3.0*CZ[HZ][3]-dy); //Ist-Volumen wird um Ueberlappung reduziert
		 CZ[HZ][4]=CZ[HZ][4]-dV;
	      
		 dy=CZ[HP][3]-d/2+dr;
		 BN[HP][bond[HP]][2]=dy;
		 dh=2.0*CZ[HP][3]*dy-dy*dy ;
		 BN[HP][bond[HP]][3]=Pi*dh;
		 dV=Pi/3.0*dy*dy*(3.0*CZ[HP][3]-dy);
		 CZ[HP][4]=CZ[HP][4]-dV;
	      
		 bond[HZ]=bond[HZ]+1;
		 if (bond[HZ]>MAX_NEIGHB-1) { printf("error:Zelle haette zuviele Nachbarn: HZ=%d,(%f,%f,%f),r=%f\n",HZ,CZ[HZ][0],CZ[HZ][1],CZ[HZ][2],CZ[HZ][3]); exit(0);} //Zelle haette mehr als 16 Nachbarn
		 bond[HP]=bond[HP]+1; //Die andere Zelle haette mehr als 16 Nachbarn
		 if (bond[HP]>MAX_NEIGHB-1) {  printf("error:Zelle haette zuviele Nachbarn: HZ=%d,(%f,%f,%f),r=%f\n",HZ,CZ[HZ][0],CZ[HZ][1],CZ[HZ][2],CZ[HZ][3]); exit(0);}
	       }
	   }
       }
    }

 for (HZ=0; HZ<N[0]; HZ++) { CZ[HZ][5]=(double)bond[HZ]; bond[HZ]=0; }
 //Setze Anzahl der Nachbarn gleich der bei diesem Schritt gefundenen
 //und bond-Feld leeren damit es wieder verwendet werden kann
								       
 

/* Haftungs-Ueberlappung Polymere */
 for (HZ=0; HZ<M[0]; HZ++)  //Fuer alle Polymere
   { 
     { 
       if (CP[HZ][3]==1.0) //Wenn Segment mit einer Zelle verbunden ist
	 { 
	   HN=(int)CP[HZ][4]; //Nummer der anhaengenden Zelle
	   BM[HN][bond[HN]]=(double)HZ; //eintragen der Nummer des WW-Punktes bei der anhaftenden Zelle
	   bond[HN]=bond[HN]+1;
	   if (bond[HN]>PPZ)
	     {
	       printf("error:zuviele WWP fuer Zelle %d:%d, exitins\n",HN,bond[HN]);
	       exit(0);
	     }
	 } 
     }     
   }
 for (HZ=0; HZ<N[0]; HZ++) //Fuer alle Zellen
   {  
     if (bond[HZ]>0) //Wenn die Zelle an Polymere gebunden ist
       { 
	 BW[HZ][0]=1.0; //Flag fuer Bindung an Boden setzen
	 BW[HZ][4]=(double)bond[HZ]; // ???
       }
     else       
      { 
	BW[HZ][0]=0.0; //Flag fuer Bindung an Boden auf 0 setzen
	BW[HZ][4]=0.0; //?
      }
 // !!!
 // was ist der Unterschied zw. BW und BM, bzw. warum wird der WW-Punkt zweimal gespeichert?
 

    /* Korrektur WW-Konstante Attraktion */
    HP=(int)CZ[HZ][5]; //Anzahl der Nachbarn
    for (i=0;i<HP;++i)  //Fuer alle Nachbarn
      BN[HZ][i][4]=WZad;

    /* Korrektur WW-Konstante Attraktion */
    BW[HZ][5]=CZ[HZ][MUT_OFFSET+MUT_SUBSTADH];
     
    BW[HZ][5]=BW[HZ][5]/(double)BW[HZ][4];
//     printf(" corr: %f\n",BW[HZ][5]);
   }
 
 return;  
}

/* Unterprogramm zur Berechnung des Systemstatus Polymere*/

void statusPP(CP,CZ,BW,BN,N,M,Z)
matrixP         CP;
matrixZ         CZ;
matrixW         BW;
matrixAZ        BN;
feldA           N,M;
feldZ           Z;

{    
  int  i,j,k,HZ,HP,HPP,HZm;
  double d,dr,zuz,dq,dmin;
  
  //printf("anfang statusPP N[0]:%d,CZ[0][3]:%f\n",N[0],CZ[0][3]);
  for (HZ=0; HZ<M[0]; HZ++)  //Fuer alle WW-Punkte
    { 
      
      for (j=3; j<5; j++) 
	{CP[HZ][j]=0.0;}  //Verbindungen zu Zellen auf 0 seten
      CP[HZ][9]=0.0; //Abstand zum Mittelpunkt der angehangenen Zelle
	
    }
  

  dmin=5000;
  for (HP=0; HP<N[0]; HP++)  //fuer alle Zellen
    {
      dq=CZ[HP][3];//Quadrieren geht schneller als Wurzel
      dq=dq*dq;
      //printf("dq:%f",dq);
      //printf("M[0]:%d",M[0]);
      for (HZ=0; HZ<M[0]; HZ++) //fuer alle Polymere
	{ 
	  d=CZ[HP][2]-CP[HZ][2];
	  d=d*d;
	  if (d<=dq)
	    {
	      for (i=0; i<2; i++) //Berechnung des Abstandes zwischen der Zelle und dem WW-Punkt
		{ 
		  dr=CZ[HP][i]-CP[HZ][i]; 
		  d+=dr*dr;
		};
	  
	      //printf("d:%f ",d);
	      //printf("HP:%d,CZ[HP][3]:%f\n",HP,CZ[HP][3]);
	      
	      if (d<=dq) //Wenn WW-Punkt in Zelle liegt (Abstand<Radius der Zelle)
		{ 
		  //printf("drin,d=%f HZ=%d ",d,HZ);
		  if (CP[HZ][3]==1.0) //Wenn an dem WW-Punkt schon eine Zelle haengt
		    {
		      zuz=zufall(0.0,1.0);
		      if (zuz>0.5) //verdraengt die Zelle nur in 50 % diejenige, die schon da haengt
			{
			  CP[HZ][3]=1.0;
			  CP[HZ][4]=(double)HP; //Nummer der Zelle
			  CP[HZ][9]=sqrt(d); //Abstand WW-Punkt - Zellmittelpunkt
			}
		    }
		  else //Wenn das Polymer noch keine Zelle traegt, heftet sie sich an
		    {
		      CP[HZ][3]=1.0;
		      CP[HZ][4]=(double)HP; //Nummer der Zelle
		      CP[HZ][9]=sqrt(d); //Abstand WW-Punkt - Zellmittelpunkt
		    }
		}	
	    }   
	  
	}
    }
  return;    
}


/* Unterprogramm  TranslationPP */

void transP(CP,FPges,CZ,FZges,BW,BN,BM,N,M,T,Z)
matrixP         CP,FPges;
matrixZ         CZ,FZges;
matrixW         BW;
matrixAZ        BN;
matrixAP        BM;
feldA           N,M;
feldT           T;
feldZ           Z;

{
  int  i,ii,j,jj,k,HZ,HN,HP,HPP;
  double d,dr,db,dmax,an,ap,zuz,f;
  
  typedef double mat0[ZSIZE][3][3];
  typedef double mat1[ZSIZE][17][3][3];
  typedef double mat2[ZSIZE][4];
  typedef double mat3[3];
 

  mat0    RWMA={0};
  mat1    RZMA={0};
  mat2    Fres={0}, Fneu={0};
  mat3    Norm={0};
  
  
  /* Berechnung der Reibung */
  
  
/* Matrix XYZ*/
/* Loesungsmittel */
  for (HZ=0; HZ<N[0]; HZ++)  //Fuer alle Zellen 
    {
      for (i=0; i<3; i++) 
	{ 
	  for (j=0; j<3; j++) 
	    { 
	      RWMA[HZ][i][j]=0.0;
	      if (i==j) 
		{ RWMA[HZ][i][j]=eta0; }
	    }
	} //Matrix mit Diagonale=eta0
      
      /* Substrat + Polymer */
   
       /* Substrat + Polymer */
      if (BW[HZ][0]==1.0)  //wenn Zelle an Boden gebunden
	{  
	  for (i=0; i<3; i++) 
	    { 
	      if ((int)(CZ[HZ][LINEAGE])==LIN_PAN)
		RWMA[HZ][i][i]=etaS_PAN;  //Reibung steht in Diagonale und ist anders fuer Paneth-Zellen
	      else
		RWMA[HZ][i][i]=etaS;
	    }
	};
	  
      
      /* Zell-Zell-Reibung */
      for (HP=0; HP<(int)CZ[HZ][5]; HP++) //fuer alle Nachbarzellen
	{ 
	  k=(int)BN[HZ][HP][0];
          an=etaN*BN[HZ][HP][3]; //Energie=anchorage*Flaeche
	  ap=etaP*BN[HZ][HP][3];

	  for (i=0; i<3; i++) 
	    { Norm[i]=(CZ[HZ][i]-CZ[k][i])/BN[HZ][HP][1]; }
	  for (i=0; i<3; i++) 
	    { 
	      for (j=0; j<3; j++) 
		{ RZMA[HZ][HP][i][j]=0.0;  }
	    }

	  for (i=0; i<3; i++) 
	    { 
	      for (j=0; j<3; j++) 
		{
		  RZMA[HZ][HP][i][j]=RZMA[HZ][HP][i][j]+(an-ap)*Norm[i]*Norm[j];
		  RWMA[HZ][i][j]=RWMA[HZ][i][j]+(an-ap)*Norm[i]*Norm[j];
		  if (i==j) 
		    { 
		      RZMA[HZ][HP][i][j]=RZMA[HZ][HP][i][j]+ap;
		      RWMA[HZ][i][j]=RWMA[HZ][i][j]+ap; 
		    }
		}
	    }
	}
    }
  
  
/* Iteration */
for (HZ=0; HZ<N[0]; HZ++) 
  {
    for (i=0; i<3; i++)  
      { Fres[HZ][i]=FZges[HZ][i];}
//printf("DEBUG: init Fres: HZ:%i FZges:(%f,%f,%f)\n",HZ,Fres[HZ][0],Fres[HZ][1],Fres[HZ][2]);

  }
 
 dmax=1.0; dr=0.0;
 while (dmax>0.01) 
   {
     dr=dr+1.0;
     for (i=0; i<N[0]; i++) 
       {
	 for (ii=0; ii<3; ii++) 
	   {
	   d=0.0;
	   for (jj=0; jj<3; jj++) 
	     {
	       if (ii==jj) {}
	       else { d=d+RWMA[i][ii][jj]*Fres[i][jj];} 
	     }
	   for (j=0; j<(int)CZ[i][5]; j++) 
	     { 
	       k=(int)BN[i][j][0];
	       for (jj=0; jj<3; jj++)     
		 {d=d-RZMA[i][j][ii][jj]*Fres[k][jj];}
	     }
	   Fneu[i][ii]=(FZges[i][ii]-d)/RWMA[i][ii][ii];
	   }
       }
     dmax=0.0;
     for (i=0; i<N[0]; i++) 
       { 
	 d=0.0; db=0.0;
	 for (ii=0; ii<3; ii++) 
	   { 
	     d=d+(Fres[i][ii]-Fneu[i][ii])*(Fres[i][ii]-Fneu[i][ii]);
	     db=db+Fneu[i][ii]*Fneu[i][ii];
	     Fres[i][ii]=Fneu[i][ii]; 
	   }
//printf("DEBUG: neu Fres: HZ:%i FZges:(%f,%f,%f)\n",i,Fres[i][0],Fres[i][1],Fres[i][2]);

	 if (db>0.0) 
	   { d=sqrt(d/db); } 
	 else 
	   { d=0.0;}
	 if (d>dmax) 
	   { dmax=d; }
       }
     
     if (dr>15.0) { /* printf("%f \n",dmax);*/ dmax=0.0; }
     
   }

 
for (HZ=0; HZ<N[0]; HZ++) 
  {
    for (i=0; i<3; i++)  
      {
	FZges[HZ][i]=Fres[HZ][i]; 
      }
  }
 
/* Betragsberechnung */
for (HZ=0; HZ<N[0]; HZ++) 
  { 
    d=0.0;
    for (j=0; j<3; j++) 
      {
	dr=FZges[HZ][j]*FZges[HZ][j];
	d=d+dr; 
      }
    d=sqrt(d);
    FZges[HZ][4]=d;    
}
 
return; 
}


/* Unterprogramm  RadiuskorrekturPP */

void radiusP(CZ,FZges,BW,BN,BM,N,T,Z)
matrixZ         CZ,FZges;
matrixW         BW;
matrixAZ        BN;
matrixAP        BM;
feldA           N;
feldT           T;
feldZ           Z;

{    
  int  i,imax,j,k,HZ,HP,HV;
  double d,dr,db,dmax,an,ap,zuz;
  
  typedef double mat2[ZSIZE][4];
  typedef double mat0R[ZSIZE];
  typedef double mat1R[ZSIZE][17];
 
  mat2    Fres={0}, Fneu={0};
  mat0R   RWRA={0};
  mat1R   RZRA={0};
  
  
  i=0;
  //printf("Anfang von radiusP:N[0]:%d,CZ[0][3]:%f\n",N[0],CZ[0][3]);
  /* Matrix Radius */
  /* Loesungsmittel */
  for (HZ=0; HZ<N[0]; HZ++)  //fuer alle Zellen
    { 
      RWRA[HZ]=etaV;
    
    /* Substrat + Polymer */
    
      if (BW[HZ][0]>0.0) //Zelle an WWP gebunden
      { 
	HP=(int)BW[HZ][4];
	RWRA[HZ]=RWRA[HZ]+HP*etaN;
      }

      /* Zell-Zell-Reibung */
      for (HP=0; HP<(int)CZ[HZ][5]; HP++) //fuer alle Nachbarzellen
	{ 
	  an=etaN*BN[HZ][HP][3];
	  RZRA[HZ][HP]=an;
	  RWRA[HZ]=RWRA[HZ]+an; //RWRA=etaV+etaV*etaN*(Anzahl WWP)+Summe(Adhaesionsenergie zu Nachbarzellen)
	}
      
    }
  
  
  /* Iteration */
  for (HZ=0; HZ<N[0]; HZ++) 
    { Fres[HZ][3]=FZges[HZ][3];}
  
  dmax=1.0; dr=0.0;
  while (dmax>0.01) 
    {
      dr=dr+1.0;
      for (i=0; i<N[0]; i++) 
	{
	  d=0.0;
	  for (j=0; j<(int)CZ[i][5]; j++) 
	    { 
	      k=(int)BN[i][j][0];
	      d=d+RZRA[i][j]*Fres[k][3];
	    }
	  Fneu[i][3]=(FZges[i][3]-d)/RWRA[i];
	}
      dmax=0.0;
      for (i=0; i<N[0]; i++) 
	{ 
	  d=(Fres[i][3]-Fneu[i][3])*(Fres[i][3]-Fneu[i][3]);
	  Fres[i][3]=Fneu[i][3];
	  d=sqrt(d);
	  if (d>dmax) 
	    { dmax=d; imax=i;}
	}

      if (dr>12.0) 
	{  printf("%f \n",dmax); dmax=0.0; }
    }
  

  for (HZ=0; HZ<N[0]; HZ++) 
    { FZges[HZ][3]=Fres[HZ][3]; }


  for (HZ=0; HZ<N[0]; HZ++) 
    {
      if (FZges[HZ][3]>0.0) 
	{ FZges[HZ][5]=+FZges[HZ][3]; }
      else                  
	{ FZges[HZ][5]=-FZges[HZ][3]; }
    }


  //printf("Ende von radiusP:N[0]:%d,CZ[0][3]:%f\n",N[0],CZ[0][3]);
  
  return; 
}



/* Unterprogramm  Wachstum */
          
void proliferation(CZ,BW,N,T,Z,BN)
     matrixZ         CZ;
     matrixW         BW;
     feldA           N;
     feldT           T;
     feldZ           Z;
     matrixAZ BN;

{    
  int  i,j,k,HZ,HP;
  double dr,zuz,delta;
  int notched,winted,old,revers,nn;

  for (HZ=0; HZ<N[0]; HZ++) 
    {
      old=(int)(CZ[HZ][LINEAGE]);
      revers=((CZ[HZ][LINEAGE]!=LIN_PAN) || (CZ[HZ][PROL_STAT]>0));
      
      if (CZ[HZ][2]<dDS)
	{
	  if (revers) //fuer irreversibel differenzierte Zellen muss nicht mehr gerechnet werden
	    {
	      notched=1;
	      winted=(CZ[HZ][2]<LS);
	      if (echt)
		{
		  nn=(int)CZ[HZ][5]; //Anzahl der Nachbarzellen
		  delta=0;
		  for (i=0;i<nn;++i)
		    {
		      delta+=CZ[(int)BN[HZ][i][0]][DELTA];
		    }
/*this is the amount, a SC requires to activate notch in the crypt bottom*/
#ifdef BNOTCH_NICHE
		  /*correct the delta uptake*/
		  if (winted) delta/=BNOTCH_NICHE;
#endif
#ifdef BNOTCH_TISSUE
                  /*correct the delta uptake*/
                  if (!winted) delta/=BNOTCH_TISSUE;
#endif

		  notched=(delta>=CZ[HZ][MUT_OFFSET+MUT_NOTCH]);

		//  printf("delta:%f,required:%f,\n",delta,CZ[HZ][MUT_OFFSET+MUT_NOTCH]);
		}
#ifdef WNT_HIGH
	     winted=1;
#endif

#ifdef WNT_LOW
	     winted=0;
#endif
	      
	      
#ifdef NOTCH_HIGH
	      notched=1; 
#endif
	      
#ifdef NOTCH_LOW
	      notched=0;
#endif
              int lin_pre=CZ[HZ][LINEAGE];	     
	      
	      /* winted==1: 	cell is in niche - it is a SC
	       * winted>0:	cell is outwards niche, but carries a mutation that maintain SC state
	       * else:		cell is outwards - it is a EC
	       * */

#if MUTATE!=MUT_OFF
#  if MUT_TYPE==MUT_APC
	      /*this cell is outwards the SC niche, but carries the APC mutation and remain as SC, as long as delta is expressed by neighbour cells*/
              if (CZ[HZ][MUT_OFFSET+MUT_APC]>0.9 && CZ[HZ][2]>LS) winted=MUT_OFFSET+MUT_APC;
#  endif
#endif

	      if (winted)
		{
		  CZ[HZ][LINEAGE]=LIN_SC;
		}
	      else
		{
		  CZ[HZ][LINEAGE]=LIN_ENTERO;
		}
	      
	      if (!notched)
		{
		  /*SC is in niche*/
		  if ((int)(CZ[HZ][LINEAGE])==LIN_SC && winted!=MUT_OFFSET+MUT_APC)
		    {
		      CZ[HZ][LINEAGE]=LIN_PAN;
		    }
		  else //if (CZ[HZ][LINEAGE]==LIN_ENTERO)
		    {
		      CZ[HZ][LINEAGE]=LIN_GOBLET;
		    }
		}
	      
	      int bool_prol_stat=1; //ON

	      /*outwards the SC niche*/
	      if (((int)(CZ[HZ][LINEAGE])==LIN_PAN) || ((int)(CZ[HZ][LINEAGE])==LIN_GOBLET)) bool_prol_stat=0;

#if MUTATE!=MUT_OFF
#  if MUT_TYPE==MUT_APC
	      /*mutant is outwards the SC niche*/
    	      if (winted==MUT_OFFSET+MUT_APC && CZ[HZ][2]>dDS) bool_prol_stat=0;
#  endif
#endif
	      if (!bool_prol_stat)
		{
		  if (CZ[HZ][PROL_STAT]!=0)
		    CZ[HZ][PROL_STAT]=1;
		}
	      else
		{
		  CZ[HZ][PROL_STAT]=2;
		};

	      //NOTE: if cell_type has changed
	      if (lin_pre!=CZ[HZ][LINEAGE])
	        get_lineage_mutate_property(CZ,HZ);
	    };
	};
      
#ifdef BAUM
      if (old!=(int)(CZ[HZ][LINEAGE]))
	{
	  printf("leben-line:%d,%d,%f\n",(int)CZ[HZ][UID],(int)(CZ[HZ][LINEAGE]),T[0]);
	}
#endif
      
      if (((int)(CZ[HZ][LINEAGE])!=LIN_PAN) && ((int)CZ[HZ][LINEAGE]!=LIN_GOBLET))
	{
	  if (CZ[HZ][PROL_STAT]==2)
	    {
	      if (CZ[HZ][2]>dDS) //Wenn eine proliferiende Zelle ueber die Differenzierungsschwelle kommt
		CZ[HZ][PROL_STAT]=1; //aendert sie ihren Status auf differenzierend
	    };
	  
	  if (CZ[HZ][PROL_STAT]==1)
	    {
	      if (CZ[HZ][2]<dDS) //Wenn eine differenzierende Zelle wieder nach unten rutscht
		CZ[HZ][PROL_STAT]=2; //wird sie wieder proliferierend
	    };
	};
      
      if (CZ[HZ][PROL_STAT]>0) //Eine Zelle proliferiert, bis sie sich endgueltig differenziert hat
	{  
	  if (CZ[HZ][4]>V0*(1.0-CZ[HZ][MUT_OFFSET+MUT_CONTACTINH])) //Wenn die Zelle nicht kontaktinhibiert ist
	    {
	      zuz=zufall(0.0,1.0);
	      if (zuz<Wprol*T[1]/CZ[HZ][MUT_OFFSET+MUT_CYCLETIME]) 
		{ CZ[HZ][6]=CZ[HZ][6]+1e-12+V0/Wprol; }
	      
	    } 
	}
      
      CZ[HZ][DELTA]=0;
      
      if (((int)(CZ[HZ][LINEAGE])==LIN_PAN) || ((int)(CZ[HZ][LINEAGE])==LIN_GOBLET))
	CZ[HZ][DELTA]=1;
    }
  return; 
};



  /*  Unterprogramm Apoptose  */
  
  
void apoptoseP(CP,CZ,BW,BN,BM,Zyklus,N,M,T,Z)
matrixP          CP;
matrixZ          CZ;
matrixW          BW;
matrixAZ         BN;
matrixAP         BM;
feldW             Zyklus;
feldA             N,M;
feldT             T;
feldZ             Z;

{    
  int  i,j,jj,k,k0,HZ,HP,HP0,test;
  double d,dr,zuz;
  
  typedef int  feldC[ZSIZE];
  feldC  CN={0}, CZZ={0}, MZ={0};
  

  /* Apoptose */

  HZ=0; HP0=N[1];
  for(HZ=N[0]-1;HZ>=0;HZ--) 
    {
      //dr=CZ[HZ][0]*CZ[HZ][0]+CZ[HZ][1]*CZ[HZ][1];
      //dr=sqrt(dr);
      
      if (CZ[HZ][2]>KICKPOINT) //Wenn Zelle den Kreis verlaesst, wird sie eliminiert
	{
	  printf("Apoptose am Rand: N=%d, p=(%f,%f) t=%f\n",N[1]+1,CZ[HZ][0],CZ[HZ][1],T[0]);
#ifdef BAUM
	  printf("leben-rand:%d,%d,%f\n",(int)(CZ[HZ][UID]),(int)(CZ[HZ][LINEAGE]),T[0]); 
#endif
	  eliminate(CZ,HZ,N,T,BW);
	  N[1]=N[1]+1;
	}
      
      else if (BW[HZ][0]==0.0) 
	{
	    {
	      printf("Apoptose durch Substratverlust:N= %d   H= %f  t=%f  p=(%f,%f)|%f \n",N[1]+1,CZ[HZ][2],T[0],CZ[HZ][0],CZ[HZ][1],CZ[HZ][LINEAGE]);
	      if ((int)(CZ[HZ][LINEAGE])==3) printf("paneth:Paneth-Zelle abgeloest\n");
#ifdef BAUM
	      printf("leben-anoi:%d,%d,%f\n",(int)(CZ[HZ][UID]),(int)(CZ[HZ][LINEAGE]),T[0]);
#endif
	      eliminate(CZ,HZ,N,T,BW);
	      N[1]=N[1]+1;
	    } 
	}
      
      else if ((int)(CZ[HZ][LINEAGE])==LIN_PAN)
	{
#ifdef PAN_Lifetime
	  zuz=zufall(0.0,1.0)*PAN_Lifetime;
	  if (zuz<T[1])
	    {
	      printf("Paneth-Lebensende Apoptose N= %d   Hd= %f\n",N[1]+1,CZ[HZ][2]);
#  ifdef BAUM
              printf("leben-anoi:%d,%d,%f\n",(int)(CZ[HZ][UID]),(int)(CZ[HZ][LINEAGE]),T[0]);
#  endif
	      eliminate(CZ,HZ,N,T,BW);
	      N[1]=N[1]+1;
	    }
#endif //PAN_Lifetime

#ifdef PAN_APOPTOSE_NO_NEIGH_WITH_NOTCH_RECEPTOR
	/*NOTE: if Paneth cell is alive, another way to become apoptotic*/
#  ifdef PAN_Lifetime
	  else 
#  endif //PAN_Lifetime
	  {
	    /*NOTE: has paneth cell at least one notch ligand neighbour*/
	    unsigned short int nr_nei=0;

	    HP=(int)CZ[HZ][5]; //Anzahl der Nachbarn
	    for (i=0; i<HP; i++) {  //Fuer alle Nachbarn
	      int lin_c=(int)(BN[HZ][i][6]);
	      if (lin_c==LIN_SC || lin_c==LIN_ENTERO) {
		nr_nei=1;
		break;
	      }
	    }

	    /*no stem cell neighbour - apoptose?*/
	    if (!nr_nei) {
	      zuz=zufall(0.0,1.0)*PAN_APOPTOSE_NO_NEIGH_WITH_NOTCH_RECEPTOR;
	      if (zuz<T[1]) {
		printf("Paneth-Lebensende (kein Nachbar mit Notch Ligand) Apoptose N= %d   Hd= %f  zuz= %f\n",N[1]+1,CZ[HZ][2],zuz);
#  ifdef BAUM
		printf("leben-anoi:%d,%d,%f\n",(int)(CZ[HZ][UID]),(int)(CZ[HZ][LINEAGE]),T[0]);
#  endif
		eliminate(CZ,HZ,N,T,BW);
		N[1]=N[1]+1;
	      }
	    }
	  }
#endif
	}
    }

  if (HP0<N[1]) 
    { 
      statusPP(CP,CZ,BW,BN,N,M,Z);
      statusZP(CP,CZ,BW,BN,BM,N,M,T);
    }
  
  
  /* Clusteranalyse */
  HP0=N[2];
  for (i=0; i<N[0]; i++) 
    {
      if (CN[i]==0) 
	{ 
	  CN[i]=i+1;  CZZ[CN[i]]=1; MZ[CN[i]]=CN[i]; 
	}
      for (k=0; k<(int)CZ[i][5]; k++) 
	{
	  HP=CN[(int)BN[i][k][0]];
	  if (HP==0) 
	    { 
	      CN[(int)BN[i][k][0]]=CN[i];
	      CZZ[CN[i]]=CZZ[CN[i]]+1; 
	    }
	  else       
	    { 
	      HZ=CN[i];
	      while((MZ[HZ]-HZ)*(MZ[HZ]-HZ)>0) 
		{ HZ=MZ[HZ]; }
	      while((MZ[HP]-HP)*(MZ[HP]-HP)>0) 
		{ HP=MZ[HP]; }
	      if (HP<HZ) 
		{ MZ[HZ]=CN[(int)BN[i][k][0]]; }
	      if (HP>HZ) 
		{ MZ[HP]=CN[i];  }
	    }
	}
    }
  
  for (i=0; i<N[0]; i++) 
    { 
      HZ=CN[i];
      while((MZ[HZ]-HZ)*(MZ[HZ]-HZ)>0) 
	{
	  CZZ[HZ]=CZZ[HZ]-1;
	  HZ=MZ[HZ];
	  CZZ[HZ]=CZZ[HZ]+1;
	}
      CN[i]=HZ;
    }
  
/* Kontaktanalyse */
for (i=0; i<N[0]; i++) 
  { 
    if (BW[i][0]==0.0) 
      {
	test=0; k=0;
	if (CZ[i][5]>0.0) 
	  {
	    for (j=0; j<N[0]; j++) 
	      { 
		if (CN[j]==CN[i]) 
		  {
		    k=k+1;
		    if (j<=i) 
		      { test=1; j=N[0];}
		    else 
		      {
		      if (BW[j][0]==1.0) 
			{ test=1; j=N[0]; } 
		      }
		    if (k==CZZ[CN[i]])
		      { j=N[0]; }
		  }
	      }
	  }

	  if (test==0)
	    {
	      k=0;
              for (j=N[0]-1; j>i-1; j--) 
		{ 
		  if (CN[j]==CN[i]) 
		    {
		      k=k+1; k0=CZZ[CN[i]];
		      
		      printf("Apoptose im Cluster NV= %d   HV= %f \n",N[2]+1,CZ[j][2]);

		      if (Zyklus[j][0]>0.0)
			{ N[3]=N[3]-1; }
		      for (HP=j+1; HP<N[0]; HP++) 
			{
			  BW[HP-1][0]=BW[HP][0];
			  for (jj=0; jj<6; jj++) 
			    { Zyklus[HP-1][jj]=Zyklus[HP][jj]; }
		       for (jj=0; jj<ZFELDER; jj++) 
			 { CZ[HP-1][jj]=CZ[HP][jj]; }
		       CN[HP-1]=CN[HP];
			}
		      BW[N[0]-1][0]=0.0;
		      for (jj=0; jj<6; jj++) 
			{ Zyklus[N[0]-1][jj]=0.0; }
		      for (jj=0; jj<ZFELDER; jj++) 
			{ CZ[N[0]-1][jj]=0.0;}
		      
		      N[0]=N[0]-1; N[2]=N[2]+1;
		      if (k==k0) 
			{ j=0; }
		    }
		}
	      
	    }
      }
  }
 
if (HP0<N[2]) 
  {  /* statusZPberechnung */
    printf("statusaufruf in apoptose\n");
    statusPP(CP,CZ,BW,BN,N,M,Z);
    statusZP(CP,CZ,BW,BN,BM,N,M,T);
  }
 
 return;  
}


/* Unterprogramm  MitoseP */

void mitoseP(CP,CZ,BW,BN,BM,Zyklus,N,M,T,Z)
matrixP        CP;
matrixZ        CZ;
matrixW        BW;
matrixAZ       BN;
matrixAP       BM;
feldW           Zyklus;
feldA           N,M;
feldT           T;
feldZ           Z;

{
  int  i,j,k,HZ,HP,HN,HPP,Nflu,o;
  double zuz,d,d1,d2,y1,y2,FG;
  
  typedef double feldH[3];
  feldH    Fant={0};
  
  Nflu=N[0];
  for (HZ=0; HZ<N[0]; HZ++) 
    {
      
      if (Zyklus[HZ][0]==2.0) 
	{ 
	  if (CZ[HZ][4]>=V0)     
	    { 
	      if (Zyklus[HZ][2]==0.0) 
		{
		  Zyklus[HZ][2]=1.0;  Zyklus[HZ][3]=T[0]-Zyklus[HZ][1]; 
		}
	    }
	  if (CZ[HZ][6]>=2.0*V0) 
	    { if (Zyklus[HZ][4]==0.0); 
	      {
		Zyklus[HZ][4]=1.0;  Zyklus[HZ][5]=T[0]-Zyklus[HZ][1]; 
	      }
	    }
	}
      
      if ((CZ[HZ][6]>=2.0*V0) && (CZ[HZ][PROL_STAT]>0) )
	{ if (CZ[HZ][4]>2.0*V0) 
	    { 
	      Nflu=Nflu+1; N[4]=N[4]+1;
	      if (Zyklus[HZ][0]==2.0) 
		{ 
		  Zyklus[HZ][1]=T[0]-Zyklus[HZ][1];
		  Zyklus[HZ][0]=0.0;
		  N[3]=N[3]-1; 
		}

	      if (Zyklus[HZ][0]==1.0) 
		{ 
		  Zyklus[HZ][1]=T[0];
		  Zyklus[HZ][0]=2.0; 
		}


/* trans. Zell-Zell-Wechselwirkung */
	      for (i=0 ; i<(int)CZ[HZ][5]; i++)
		{ 
		  HP=(int)BN[HZ][i][0];
		  
		  /* Deformation */
		  d1=CZ[HZ][3]+CZ[HP][3];
		  d2=sqrt(CZ[HZ][3]*CZ[HP][3]/d1);
		  d1=pow(d1-BN[HZ][i][1],1.5)*d2;
		  FG=d1/Delast;
		  
		  /* Kompression */
		  y1=BN[HZ][i][2]; y2=CZ[HZ][3]+CZ[HP][3]-BN[HZ][i][1]-y1;
		  d1=(CZ[HZ][4]/CZ[HZ][6]-1.0)*y1/BN[HZ][i][1];
		  d1=d1*(BN[HZ][i][1]-CZ[HZ][3]+y1)*(2.0*CZ[HZ][3]-y1);
		  d2=(CZ[HP][4]/CZ[HP][6]-1.0)*y2/BN[HZ][i][1];
		  d2=d2*(CZ[HZ][3]-y1)*(2.0*CZ[HP][3]-y2);
		  d1=-d1*Pi*Kelast;
		  FG=FG+d1;
		  
		  /* Adhesion */
		  d1=(CZ[HZ][3]-BN[HZ][i][2])*(BN[HZ][i][1]+BN[HZ][i][2]-CZ[HZ][3]);
		  d1=2.0*Pi*d1/BN[HZ][i][1];
		  d1=-d1*BN[HZ][i][4];
		  FG=FG+d1;

		  for (j=0; j<3; j++) 
		    {
		      Fant[j]=Fant[j]+FG*(CZ[HZ][j]-CZ[HP][j])/BN[HZ][i][1];   
		    }
		}
	      /* Zelle mit Substratkontakt */
	      if (BW[HZ][0]==1.0) 
		{ 
		  HN=(int)BW[HZ][4];
		  /* Berechnung der Matrixposition */
		  for (j=1; j<4; j++) 
		    { BW[HZ][j]=0.0; }
		  for (i=0; i<HN; i++) 
		    {
		      HP=BM[HZ][i]; //HPP=BM[HZ][i][1];
		      for (j=1; j<4; j++) 
			{ //BW[HZ][j]=BW[HZ][j]+CP[HP][HPP][j-1]; 
			  BW[HZ][j]=BW[HZ][j]+CP[HP][j-1];
			}
		    }
		  for (j=1; j<4; j++)
		    { BW[HZ][j]=BW[HZ][j]/BW[HZ][4]; }
		  
		  d1=0.0; d2=0.0;
		  for (j=1; j<4; j++) 
		    { d1=d1+(BW[HZ][j]-CZ[HZ][j-1])*(BW[HZ][j]-CZ[HZ][j-1]);
		      d2=d2+(BW[HZ][j]-CZ[HZ][j-1])*Fant[j-1]; 
		    }
		  d1=sqrt(d1); d2=d2/d1;
		  for (j=0; j<3; j++) 
		    { Fant[j]=Fant[j]-d2*(BW[HZ][j+1]-CZ[HZ][j])/d1; }
		  d1=0.0 ;
		  for (j=0; j<3; j++) 
		    {  d1=d1+Fant[j]*Fant[j]; }

		  while   (d1==0.0) 
		    {
		      for (j=0; j<3; j++) 
			{ 
			  zuz=zufall(-1.0,1.0);
			  Fant[j]=zuz; 
			}
		      d1=0.0; d2=0.0;
		      for (j=1; j<4; j++) 
			{ 
			  d1=d1+(BW[HZ][j]-CZ[HZ][j-1])*(BW[HZ][j]-CZ[HZ][j-1]);
			  d2=d2+(BW[HZ][j]-CZ[HZ][j-1])*Fant[j-1]; 
			}
		      d1=sqrt(d1); d2=d2/d1;
		      for (j=0; j<3; j++) 
			{ Fant[j]=Fant[j]-d2*(BW[HZ][j+1]-CZ[HZ][j])/d1;}
		      d1=0.0 ;
		      for (j=0; j<3; j++)
			{  d1=d1+Fant[j]*Fant[j]; }
		    }  
		}
	      
	      /* Zelle ohne Substratkontakt */
	      else 
		{
		  d1=0.0 ;
		  for (j=0; j<3; j++)
		    {  d1=d1+Fant[j]*Fant[j]; }
		  
		  while   (d1==0.0) 
		    {
		      for (j=0; j<3; j++) 
			{
			  zuz=zufall(-1.0,1.0);
			  Fant[j]=zuz; d1=d1+zuz*zuz; 
			}
		    }  
		}
	      
	      d1=sqrt(d1);
	      
	      
    
	      for (j=0; j<3; j++) 
		{  
		  CZ[Nflu-1][j]=CZ[HZ][j]+0.1*Fant[j]/d1;
		  CZ[Nflu-1][8+j]=CZ[Nflu-1][j]; 
		}
	      CZ[Nflu-1][3]=CZ[HZ][3];
	      CZ[Nflu-1][6]=V0;CZ[HZ][6]=V0;
	      CZ[Nflu-1][PROL_STAT]=CZ[HZ][PROL_STAT];

	      for(o=0;o<nmark;o++)
		{
		  mf[Nflu-1][o]=0;
		  if (mf[HZ][o]==1)
		    mf[Nflu-1][o]=1;
		  
		};
	      //printf("status,tut:Mitose: (%f,%f,%f),%f\n",CZ[HZ][0],CZ[HZ][1],CZ[HZ][2],CZ[HZ][LINEAGE]);
	      //if (((int)(CZ[HZ][LINEAGE])==LIN_PAN) || ((int)(CZ[HZ][LINEAGE])==LIN_GOBLET))
	      //printf("error:Mitose einer sekretorischen Zelle:typ=%f\n",CZ[HZ][LINEAGE]); 
	      //if (CZ[HZ][LINEAGE]==LIN_SC)
	      //printf("tut:SC-Mitose\n");
	       
	      CZ[Nflu-1][LINEAGE]=CZ[HZ][LINEAGE]; //lineage Information wird vererbt
//	      Proliferationszustand wird auch vererbt
	      if (CZ[HZ][PROL_STAT]==1)
		{
		  CZ[HZ][PROL_STAT]=0; //wenn die Zelle eine differenzierende war, ist sie das nach der Teilung nicht mehr
		};
              CZ[Nflu-1][PROL_STAT]=CZ[HZ][PROL_STAT]; //Proliferationszustand wird auch vererbt


	      /*vererbe mutierte Eigenschaften (tatsaechlicher Wert 0..NMUT-1 und Mutation der Stammzelle NMUT..2*NMUT-1)
	       * this data is always required, even though mutation is off*/
	      int i;
	      for (i=0;i<NMUT*2;++i)
	      {
		CZ[Nflu-1][MUT_OFFSET+i]=CZ[HZ][MUT_OFFSET+i];
		CZ[Nflu-1][MUT_OFFSET+i+NMUT]=CZ[HZ][MUT_OFFSET+i+NMUT];
	      }
	      
#ifdef BAUM
	      printf("leben-teil:%d,%d,%f\n",(int)CZ[HZ][UID],nextind,T[0]);
	      printf("pos-teil:(%f,%f,%f)\n",CZ[HZ][0],CZ[HZ][1],CZ[HZ][2]);
#endif //BAUM

              CZ[HZ][ANCESTOR]=CZ[HZ][UID];
	      CZ[Nflu-1][ANCESTOR]=CZ[HZ][UID];
	      CZ[HZ][UID]=nextind;CZ[Nflu-1][UID]=nextind+1;nextind+=2;
	      CZ[HZ][MITO_T]=T[0];CZ[Nflu-1][MITO_T]=T[0]; //save t of current mitose

#ifdef BAUM
	      printf("leben-line:%d,%d,%f\n",(int)CZ[HZ][UID],(int)(CZ[HZ][LINEAGE]),T[0]);
	      printf("leben-line:%d,%d,%f\n",(int)CZ[Nflu-1][UID],(int)(CZ[Nflu-1][LINEAGE]),T[0]);
#endif //BAUM

	      CZ[Nflu-1][12]=(double)N[4];
	    } 
	} 
    }
  
  if (Nflu>N[0]) 	//NOTE: why did it sometimes not work? => if number of cells decreases during apoptose?
    { 
      N[0]=Nflu; /* statusZPberechnung */
      statusPP(CP,CZ,BW,BN,N,M,Z);
      statusZP(CP,CZ,BW,BN,BM,N,M,T);   
    }
  
  return;    
}




/* Funktion zur Berechnung der Kraefte zwischen Zellen */
/* Translation */

void fZwzz(CZ,FZges,BN,N)
matrixZ        CZ,FZges;
matrixAZ       BN;
feldA          N;

{
  int  i,j,k,HZ,HP,HN;
  double Fwzz,d1,d2,y1,y2;
  
  typedef double feldH[3] ;
  feldH    Fant={0};
  
/* Deformation */
  for (HZ=0; HZ<N[0];HZ++) //Fuer alle Zellen
    {
      for (i=0;i<(int)CZ[HZ][5];i++)  //Fuer alle Nachbarn der Zelle
	{
	  HP=(int)BN[HZ][i][0]; //Nummer der Nachbarzelle
	  d1=CZ[HZ][3]+CZ[HP][3]; //Durchmesser der Zelle
	  d2=sqrt(CZ[HZ][3]*CZ[HP][3]/d1);
	  Fwzz=pow(d1-BN[HZ][i][1],1.5)*d2/Delast; //Gleichung 2 des Papers
	  for (j=0; j<3; j++) 
	    {  
	      Fant[j]=(CZ[HZ][j]-CZ[HP][j])/BN[HZ][i][1];
	      Fant[j]=Fwzz*Fant[j];
	      FZges[HZ][j]=FZges[HZ][j]+Fant[j];    
	      FZges[HZ][j+6]=FZges[HZ][j+6]+Fant[j]; 
	    }
	} 
    }
  /* Kompression */
  for (HZ=0; HZ<N[0]; HZ++) 
    {
      for (i=0 ; i<(int)CZ[HZ][5]; i++)  
	{ 
	  HP=(int)BN[HZ][i][0];
	  y1=BN[HZ][i][2]; y2=CZ[HZ][3]+CZ[HP][3]-BN[HZ][i][1]-y1;
	  d1=(CZ[HZ][4]/CZ[HZ][6]-1.0)*y1/BN[HZ][i][1];
	  d1=d1*(BN[HZ][i][1]-CZ[HZ][3]+y1)*(2.0*CZ[HZ][3]-y1);
	  d2=(CZ[HP][4]/CZ[HP][6]-1.0)*y2/BN[HZ][i][1];
	  d2=d2*(CZ[HZ][3]-y1)*(2.0*CZ[HP][3]-y2);
	  Fwzz=-(d1+d2)*Pi*Kelast;
	  for (j=0; j<3; j++) 
	    {
	      Fant[j]=(CZ[HZ][j]-CZ[HP][j])/BN[HZ][i][1];
	      Fant[j]=Fwzz*Fant[j];
	      FZges[HZ][j]=FZges[HZ][j]+Fant[j];    
	      FZges[HZ][j+6]=FZges[HZ][j+6]+Fant[j];     
	    }
	} 
    }
  /* Adhesion */
  for (HZ=0; HZ<N[0]; HZ++) 
    {
      for (i=0 ; i<(int)CZ[HZ][5]; i++)   
	{  
	  HP=BN[HZ][i][0];  HN=(int)CZ[HP][5];
	  k=0; 
	  for (j=0; j<HN; j++) 
	    { 
	      if (HZ==BN[HP][j][0]) 
		{ k=j; }
	    } 
	  d1=(CZ[HZ][3]-BN[HZ][i][2])*(BN[HZ][i][1]+BN[HZ][i][2]-CZ[HZ][3]);
	  d2=2.0*Pi*d1/BN[HZ][i][1];
	  Fwzz=-d2*BN[HP][k][4];
	  for (j=0; j<3; j++) 
	    { 
	      Fant[j]=(CZ[HZ][j]-CZ[HP][j])/BN[HZ][i][1];
	      Fant[j]=Fwzz*Fant[j];
	      FZges[HZ][j]=FZges[HZ][j]+Fant[j];   
	    }
	} 
    }
  
  return;    
}


/* Funktion zur Berechnung der Kraefte zwischen Zellen */
/* Radiusaenderung */

void fRwzz(CZ,FZges,BN,N)
matrixZ        CZ,FZges;
matrixAZ       BN;
feldA           N;

{  
  int  i,j,k,HZ,HP,HN;
  double Rwzz,d1,d2,y1,y2;
  
  /* Deformation */
  for (HZ=0; HZ<N[0]; HZ++) 
    {
      for (i=0 ; i<(int)CZ[HZ][5]; i++)   
	{ 
	  HP=(int)BN[HZ][i][0];
	  d1=(CZ[HZ][3]+CZ[HP][3]);
	  d2=1.0+CZ[HP][3]/CZ[HZ][3]/d1/5.0*(d1-BN[HZ][i][1]);
	  d2=sqrt(CZ[HZ][3]*CZ[HP][3]/d1)*d2;
	  Rwzz=-pow(d1-BN[HZ][i][1],1.5)*d2/Delast;
	  FZges[HZ][3]=FZges[HZ][3]+Rwzz;  
	}    
    }
  //printf("nach deformation Fzges[0][3]=%f\n",FZges[0][3]);
   
   /* Kompression */
  for (HZ=0; HZ<N[0]; HZ++) 
    {
      d1=(CZ[HZ][4]/CZ[HZ][6]-1.0)*CZ[HZ][3]*CZ[HZ][3];
      FZges[HZ][3]=FZges[HZ][3]-4.0*Pi*Kelast*d1;
      for (i=0 ; i<(int)CZ[HZ][5]; i++)   
	{
	  HP=(int)BN[HZ][i][0];
	  y1=BN[HZ][i][2]; y2=CZ[HZ][3]+CZ[HP][3]-BN[HZ][i][1]-y1;
	  d1=(CZ[HZ][4]/CZ[HZ][6]-1.0)*y1/BN[HZ][i][1];
	  d1=d1*(2.0*(BN[HZ][i][1]-CZ[HZ][3])+y1)*CZ[HZ][3];
	  d2=(CZ[HP][4]/CZ[HP][6]-1.0)*y2/BN[HZ][i][1];
	  d2=d2*CZ[HZ][3]*(2.0*CZ[HP][3]-y2);
	  Rwzz=(d1+d2)*Pi*Kelast;
	  FZges[HZ][3]=FZges[HZ][3]+Rwzz;
	}
    }
  
  //printf("nach Kompression Fzges[0][3]=%f\n",FZges[0][3]);
  
  /* Adhesion */
  for (HZ=0; HZ<N[0]; HZ++) 
    {
      for (i=0 ; i<(int)CZ[HZ][5]; i++)   
	{ 
	  HP=BN[HZ][i][0];  HN=(int)CZ[HP][5];
	  k=0; 
	  for (j=0; j<HN; j++) 
	    { 
	      if (HZ==BN[HP][j][0]) 
		{ k=j; }
	    } 
	  d1=CZ[HZ][3]*(BN[HZ][i][1]+BN[HZ][i][2]-CZ[HZ][3]);
	  d1=2.0*Pi*d1/BN[HZ][i][1];
	  Rwzz=d1*BN[HP][k][4];
	  FZges[HZ][3]=FZges[HZ][3]+Rwzz;
	
	}
    
    }
  //printf("nach adhaesion Fzges[0][3]=%f\n",FZges[0][3]);
  return;  
}


/* Funktion zur Berechnung der Polymer-Zell-Kopplung */
/* Translation + Radius */

void fSzp(CP,FPges,CZ,FZges,BW,M)
matrixP        CP,FPges;
matrixZ        CZ,FZges;
matrixW	   BW;
feldA          M;

{
  int  i,j,k,HN,HP;
  double d,d0;
  
  for (i=0; i<M[0]; i++) //Fuer alle WW-Punkte
    {  
      if (CP[i][3]==1.0)  //Wenn an dem WW-Punkt eine Zelle haengt
      { 
	HN=(int)CP[i][4];
	d0=BW[HN][5]/CZ[HN][3]*(RC*CZ[HN][3]/(CP[i][9]+0.001)-1.0);
	      for (k=0; k<3; k++) 
		{
		  d=(CP[i][k]-CZ[HN][k])/CZ[HN][3];
		  d=d*d0;
		  //FPges[i][j][k]=FPges[i][j][k]+d; //Kraefte auf Polymere gibts nicht mehr
		  FZges[HN][k]=FZges[HN][k]-d; //ja, das ist FZ, nicht FP
		}
	      FZges[HN][3]=FZges[HN][3]+BW[HN][5]/CZ[HN][3]*((CP[i][9]+0.001)/CZ[HN][3]-RC);
      }
    }
  
  
  return;    
};
  
  
  
/* Ausgabe */



void printPool(const char* filename,const char* color,int pool[ZSIZE],int bis,matrixZ CZ)
{
  FILE *fp_res;
  int i;
  
  fp_res=fopen(filename,"w");
  for (i=0; i<bis; i++) 
       {
	 fprintf(fp_res,"sphere { ");
	 fprintf(fp_res,"< %f, %f, %f >,",CZ[pool[i]][0],CZ[pool[i]][1],CZ[pool[i]][2]);
	 fprintf(fp_res,"%f pigment { %s}} \n",CZ[pool[i]][3],color); 
	 //if (CZ[i][LINEAGE]==2) {  fprintf(fp_res,"%f pigment { Blue }} \n",CZ[pool[i]][3]); }
	 //if (CZ[i][LINEAGE]==1) {  fprintf(fp_res,"%f pigment { Yellow } } \n",CZ[pool[i]][3]); }
	 //if (CZ[i][LINEAGE]==0) {  fprintf(fp_res,"%f pigment { Red } } \n",CZ[pool[i]][3]); }
       }
  //  fprintf(fp_res,"plane {<1,0,0>,1 pigment {color rgbf<0,1,0,1>}} \n");
  fclose(fp_res);
};
 
void eliminate(matrixZ CZ, int HZ,feldA N,feldT T,matrixW BW)
{
  int HP,j;
  
  printf("status: Zelle %d wird eliminiert, t=%f,N[0]=%d \n",HZ,T[0],N[0]);
  N[1]=N[1]+1;
  // zellreport(CZ,HZ);
  for (HP=HZ+1; HP<N[0]; HP++) 
    {
      for (j=0; j<ZFELDER; j++)
	{ 
	  CZ[HP-1][j]=CZ[HP][j]; 
	};
      for(j=0;j<nmark;j++)
	{
	  mf[HP-1][j]=mf[HP][j];
	};
    };
  for (j=0; j<ZFELDER; j++)
    { CZ[N[0]-1][j]=0.0; }
  BW[N[0]-1][0]=0.0;
  
  N[0]=N[0]-1; 
  //T[3]=T[3]+(T[0]-CZ[HZ][UID]);
};


void markiereS(matrixZ CZ, feldT T,feldA N) //Markiert die Zellen, die sich in der S-Phase befinden
{
  int i;
  int count=0;
  double zuz;

  for(i=0;i<N[0];i++)
    {
      	mf[i][nmark]=0;
	if ((CZ[i][PROL_STAT]>0))
	  {
	    zuz=zufall(0.0,1.0);
	      if (zuz<LENS)
		{
		  mf[i][nmark]=1; //Markierung setzen
		  count++;
		}
	  //printf("Markierung gesetzt\n");
	}
    };
  printf("soph:%d Zellen markiert mit Index:%d\n",count,nmark);
  nmark++;
  if (nmark>MAXMARK-1) printf("error:nmark>MAXMARK-1\n");
};

void clearmark(int nr,TFM FMess,int li,feldA N)
{
  int i,j;
  
  for (j=0;j<N[0];j++)
    {
      for(i=nr;i<nmark-1;i++)
	mf[j][i]=mf[j][i+1];
  
    };
  for(i=0;i<li;i++)
    {
      if (FMess[i].imark>nr)
	FMess[i].imark=FMess[i].imark-1;
    }
  printf("soph:Markierung %d geloescht \n",nr);
  nmark--;
}


double messpunkt(matrixZ CZ,feldT T,feldA N)
{
  
  int clearMess(TFM FMess,int p,int li)
  {
    int i;
    
    for(i=p;i<li-1;i++)
      {
	FMess[i]=FMess[i+1];
      };
    printf("soph:Messpunkt %d geloescht\n",p);
    return (li-1);
  };
 
  double takt,tnext,at;
 
 static TFM FMess;
 int i,as,ai,o;
 static int nmess;
 static int first;

 takt=T[0];

 printf("soph Messpunkt-Aufruf t=%f,nmess=%d\n",takt,nmess);
 
 if (takt==0) //Initialisierung
   {
     nmark=1;
     nmess=2;
     FMess[0].t=VORLAUF1;FMess[1].t=VORLAUF1;
     FMess[0].status=9;
     FMess[1].status=0;
     first=1;
     printf("status,soph:Messpunkte initialisiert\n");
   }

 for(i=0;i<nmess;i++)
   {
       if (FMess[i].t<=takt)
       {
	 as=FMess[i].status;ai=FMess[i].imark;
	 printf("soph: nmess vor Loeschen :%d\n",nmess);
	 if (!(as==9))
	   { //fuer die Fotos wird immer der selbe Messpunkt verwendet
	     nmess=clearMess(FMess,i,nmess);
	     printf("soph: nmess nach Loeschen :%d\n",nmess);
	   }
	 if (as==0) //Start eines Messzyklus
	   {
	     printf("soph:Richte Messzyklus ein t=%f\n",takt);
	     q++;
	     FMess[nmess].t=takt+TS1;
	     FMess[nmess+1].t=takt+TS2;

	     FMess[nmess].status=1;FMess[nmess+1].status=2;
	     FMess[nmess].imark=nmark;FMess[nmess+1].imark=nmark;
	     markiereS(CZ,T,N);
	     
	     FMess[nmess+2].t=takt+VORLAUF2;
	     FMess[nmess+2].status=0;

	     nmess=nmess+3;     
	     if (nmess>MPZ-1) printf("error:nmess>MPZ-1");
	   }
	 
	 if (as==1)
	   {
#ifdef BRDU_BILD
	     brduCells(ai,q-nmark+1,1,CZ,N,T);
#endif
	     schnitt("schnitt1.dat",CZ,N,T,ai);
	     
	   }
	 
	 if (as==2)
	   {
#ifdef BRDU_BILD
	     printCells(ai,q-nmark+1,2,CZ,N,T);
#endif
	     schnitt("schnitt2.dat",CZ,N,T,ai);

	     clearmark(ai,FMess,nmess,N);
	   }
	 
	 if (as==9)
	   {
	     FMess[0].t=takt+10;FMess[0].status=9;
	     if (first==1)
	       {
		 for(o=0;o<N[0];o++)
		   {
		     if (CZ[o][2]<-22)
		       mf[o][0]=1;
		     else
		       mf[o][0]=0;
		   };
		 
	       };
	     printCells(first,CZ,N);
	     first++;
	   };
       }
     
   }
 tnext=50000;
 for(i=0;i<nmess;i++)
   {
     if (FMess[i].t<tnext)
       tnext=FMess[i].t;
   }
 
 printf("soph:Naechster Aufruf von Messpunkt bei t=%f\n",tnext);
 return tnext;
};

void printCells(const int nr,matrixZ CZ,feldA N)
{
  FILE *fp_res;
  int i,bis;
  char filename[50]="blick";
  char s2[10]="";
  
  sprintf(s2,"%d.pov",nr);
  strcat(filename,s2);
      
  fp_res=fopen(filename,"w");
  bis=N[0];
  for (i=0; i<bis; i++) 
       {
	 fprintf(fp_res,"sphere { ");
	 fprintf(fp_res,"< %f, %f, %f >,",CZ[i][0],CZ[i][1],CZ[i][2]);
	 /*
	 if (mf[i][0]==1.0) 
	   {  fprintf(fp_res,"%f pigment { Green }} \n",CZ[i][3]); }
	 else
	 */
	   {
	     if (CZ[i][LINEAGE]==LIN_ENTERO) {  fprintf(fp_res,"%f pigment { Blue }} \n",CZ[i][3]); }
	     if (CZ[i][LINEAGE]==LIN_GOBLET) {  fprintf(fp_res,"%f pigment { Yellow } } \n",CZ[i][3]); }
	     if (CZ[i][LINEAGE]==LIN_SC) {  fprintf(fp_res,"%f pigment { Red } } \n",CZ[i][3]); }
	     if (CZ[i][LINEAGE]==LIN_PAN) {  fprintf(fp_res,"%f pigment { Green } } \n",CZ[i][3]); }
	   }
       }
  //  fprintf(fp_res,"plane {<1,0,0>,1 pigment {color rgbf<0,1,0,1>}} \n");
  fclose(fp_res);
};

void schnitt(const char* filename, matrixZ CZ, feldA N,feldT T,int nm)
{
  vector aufEbene={0,0,0};
  vector norm={1,0.0,0.0};
  double l,unteny,tst;
  int pool[ZSIZE];
  int links[ZSIZE],rechts[ZSIZE];
  char sl[ZSIZE]="",sr[ZSIZE]="";
  char gl[ZSIZE]="",pl[ZSIZE]="",gr[ZSIZE]="",pr[ZSIZE]="",scl[ZSIZE]="",scr[ZSIZE]="",mpl[ZSIZE]="",mpr[ZSIZE]="";
  int poolindex=0,rindex=1,lindex=1;
  int i;
  FILE *dat;
  

  double abstEP(int nr)
  {
    vector diff;
    int i;
    double d=0;

    for(i=0;i<3;i++)
      diff[i]=CZ[nr][i]-aufEbene[i];
    
    for(i=0;i<3;i++)
      d+=diff[i]*norm[i];
    return d;
    
  };
  
  int compz(int *i1,int *i2)
  {
    //Vergleichsfunktion fuer qsort
    if(CZ[*i1][2]<CZ[*i2][2]) return -1;
    if(CZ[*i1][2]==CZ[*i2][2]) return 0;
    else return 1;
  };
  
  //Normvektor wird in Normeinheitsvektor umgewandelt
  l=0;
  for(i=0;i<3;i++)
    l+=(norm[i]*norm[i]);
  l=sqrt(l);
  for (i=0;i<3;i++)
    norm[i]/=l;
  
  for(i=0;i<N[0];i++)
    {
      l=abstEP(i);
      if (fabs(l)<=SCHNITTDICKE)  //Zellkern ist angeschnitten
	{
	  pool[poolindex]=i;
	  poolindex++;
	};
    };
  printf("schnitt:%d Zellen angeschnitten bei Schnittdicke %f,t=%f\n",poolindex,SCHNITTDICKE,T[0]);
  //printPool(pool,poolindex,CZ);
  qsort(pool,poolindex,sizeof(int),(void*) compz);
  /*
    for(i=0;i<poolindex;i++)
    {
      l=abstEP(pool[i]);
      printf("%d:<%f,%f,%f>=",pool[i],CZ[pool[i]][0],CZ[pool[i]][1],CZ[pool[i]][2]);
      printf("%f\n",l);
    };
  */
  l=abstEP(pool[0]);
  unteny=(CZ[pool[0]][1])-(l*norm[1]);
  rechts[0]=pool[0];links[0]=pool[0];
  for(i=1;i<poolindex;i++)
    {
      l=abstEP(pool[i]);
      if ((CZ[pool[i]][1]-l*norm[1])<=unteny)
	{
	  links[lindex]=pool[i];
	  lindex++;
	}
      else
	{
	  rechts[rindex]=pool[i];
	  rindex++;
	};
    };
  printf("%d links,%d rechts,t=%f,nm=%d\n",lindex,rindex,T[0],nm);
  //printPool("rechts.pov","Blue",rechts,rindex,CZ);
  //printPool("links.pov","Red",links,lindex,CZ);

  for(i=0;i<lindex;i++)
    {

      if ((int)(CZ[links[i]][LINEAGE])==LIN_GOBLET)
	strcat(gl,"2");
      else
	strcat(gl,"1");
      
      if ((int)(CZ[links[i]][LINEAGE])==LIN_PAN)
	strcat(pl,"2");
      else
	strcat(pl,"1");


      if (((int)(CZ[links[i]][LINEAGE])==LIN_PAN) && (CZ[links[i]][PROL_STAT]==0))
	strcat(mpl,"2");
      else
	strcat(mpl,"1");

      if ((int)(CZ[links[i]][LINEAGE])==LIN_SC)
	strcat(scl,"2");
      else
	strcat(scl,"1");
      
      if (mf[links[i]][nm]==1) //Markierung gesetzt
	if (CZ[links[i]][6]>=MITOSE_SIZE*2.0*V0)  //Mitose wird bald stattfinden
	  {
	    //markierte Mitose
	    strcat(sl,"4");
	  }
	else //Markierung ohne Mitose
	  {
	    strcat(sl,"2");
	  }
      else //nicht markiert
	{
	  if (CZ[links[i]][6]>=MITOSE_SIZE*2.0*V0)  //Mitose wird bald stattfinden
	    {
	      strcat(sl,"3");
	    }
	  else //weder Markierung, noch Mitose
	    {
	      strcat(sl,"1");
	    };
	};
      
   };
for(i=0;i<rindex;i++)
    {

      if ((int)(CZ[rechts[i]][LINEAGE])==LIN_GOBLET)
	strcat(gr,"2");
      else
	strcat(gr,"1");
      
      if ((int)(CZ[rechts[i]][LINEAGE])==LIN_PAN)
	strcat(pr,"2");
      else
	strcat(pr,"1");

      if ((int)(CZ[rechts[i]][LINEAGE])==LIN_SC)
	 strcat(scr,"2");
       else
	 strcat(scr,"1");


      if (((int)(CZ[rechts[i]][LINEAGE])==LIN_PAN) && (CZ[rechts[i]][PROL_STAT]==0))
	strcat(mpr,"2");
      else
	strcat(mpr,"1");
      
      if (mf[rechts[i]][nm]==1) //Markierung gesetzt
	if (CZ[rechts[i]][6]>=MITOSE_SIZE*2.0*V0)  //Mitose wird bald stattfinden
	  {
	    //markierte Mitose
	    strcat(sr,"4");
	  }
	else //Markierung ohne Mitose
	  {
	    strcat(sr,"2");
	  }
      else //nicht markiert
	{
	  if (CZ[rechts[i]][6]>=MITOSE_SIZE*2.0*V0)  //Mitose wird bald stattfinden
	    {
	      strcat(sr,"3");
	    }
	  else //weder Markierung, noch Mitose
	    {
	      strcat(sr,"1");
	    };
	};
    };
//printf("sl:%s,sr:%s\n",sl,sr);
 dat=fopen(filename,"a");
 fprintf(dat,"%d %f %s %s\n",versuch,T[0],sl,sr); //CAVE: Versuch muss global deklariert sein
 fclose(dat);
 dat=fopen("gob_ind","a");
 fprintf(dat,"%d %f %s %s\n",versuch,T[0],gl,gr);
 fclose(dat);
 dat=fopen("pan_ind","a");
 fprintf(dat,"%d %f %s %s\n",versuch,T[0],pl,pr);
 fclose(dat);
 dat=fopen("lgr_ind","a");
 fprintf(dat,"%d %f %s %s\n",versuch,T[0],scl,scr);
 fclose(dat);
 dat=fopen("mp_ind","a");
 fprintf(dat,"%d %f %s %s\n",versuch,T[0],mpl,mpr);
 fclose(dat);
}; 



void makering(double hoehe, int n, matrixZ CZ,feldA N)
{
  double d,phi;
  double rz=1;
  int zaehler;

//  d=M_2_PI*acos(pow((hoehe/ZTiefe),1/10.0))*Lsys*Lsys; //Berechnung des Radius des Kreises auf der entspr. Ebene
  d=M_2_PI*acos(pow((hoehe/ZTiefe),Steilheit)); //Berechnung des Radius des Kreises auf der entspr. Ebene
  d=sqrt(d); 
//  d=d*(1.0+0.25*cos(hoehe*2*M_PI/ZTiefe+M_PI_2));
  d*=Lsys*(1.0+lambda1*cos(hoehe*2*M_PI/ZTiefe+M_PI_2));
  d-=rz;//+0.01; //Mittelpunkt der Zelle muss so liegen, dass die Zelle sich ein wenig mit dem Rand ueberlappt

  for(phi=0;phi<2*M_PI;phi+=(2*M_PI/n)) //Zeichnen der Punkte des n-Ecks
    {           
      zaehler=N[0];
      N[0]=N[0]+1;
      CZ[zaehler][0]=d*cos(phi);CZ[zaehler][1]=d*sin(phi);CZ[zaehler][2]=hoehe;
      CZ[zaehler][3]=rz;CZ[zaehler][4]=V0*pow(d,3);CZ[zaehler][5]=0;
      CZ[zaehler][6]=V0;CZ[zaehler][UID]=N[0];
      CZ[zaehler][8]=CZ[zaehler][0];CZ[zaehler][9]=CZ[zaehler][1];CZ[zaehler][10]=CZ[zaehler][2];
      CZ[zaehler][LINEAGE]=LIN_SC;
      CZ[zaehler][PROL_STAT]=2.0;
      CZ[zaehler][MITO_T]=.0;
      CZ[zaehler][ANCESTOR]=-1;

      /*index lineage: 0 => otherwise (DEFAULT for 1,2,4), 3 => Panethcell*/
      int i_lin=CZ[zaehler][LINEAGE];
//      if (CZ[zaehler][LINEAGE]!=LIN_PAN)
//        i_lin=0;

      printf("%i placed cell:%f at f(%f,%f,%f)\n",zaehler,CZ[zaehler][UID],CZ[zaehler][0],CZ[zaehler][1],CZ[zaehler][2]);
      int i;
      for(i=0;i<NMUT;i++)
	{
	  CZ[zaehler][MUT_OFFSET+i]=get_lineage_initial_property(i,i_lin);
	  CZ[zaehler][MUT_OFFSET+i+NMUT]=mut_params[i][2][i_lin]; //not mutated
	  printf("Cell's mutatable properties: %d %d %f %f\n",zaehler,i,CZ[zaehler][MUT_OFFSET+i],mut_params[i][2][i_lin]);
	}
      
#ifdef BAUM
      printf("leben-line:%d,%d,0\n",(int)CZ[zaehler][UID],(int)(CZ[zaehler][LINEAGE]));
#endif
    };
  N[4]=N[0];
};


void brduCells(const int ai,const int nr1,const int nr2,matrixZ CZ,feldA N,feldT T)
{
  FILE *fp_res;
  int i,bis;
  char filename[50]="brdu";
  char s2[10]="";
  double sat;
  
  sprintf(s2,"%d_%d.pov",nr1,nr2);
  strcat(filename,s2);
      
  fp_res=fopen(filename,"w");
  bis=N[0];
  fprintf(fp_res,"//t=%f,ai=%d,nr1=%d,nr2=%d,q=%d,nmark=%d\n",T[0],ai,nr1,nr2,q,nmark);
  for (i=0; i<bis; i++) 
       {
	 fprintf(fp_res,"sphere { ");
	 fprintf(fp_res,"< %f, %f, %f >,",CZ[i][0],CZ[i][1],CZ[i][2]);
	 
	 if (mf[i][ai]==1.0)
	   sat=1.0;
	 else
	   sat=0.5;
	 
	 
	   {
	     if (CZ[i][LINEAGE]==LIN_ENTERO) { fprintf(fp_res,"%f pigment { color rgb CHSV2RGB(<240,%f,1>)}} \n",CZ[i][3],sat); }
	     if (CZ[i][LINEAGE]==LIN_GOBLET) { fprintf(fp_res,"%f pigment { color rgb CHSV2RGB (<60,%f,1>)}} \n",CZ[i][3],sat); }
	     if (CZ[i][LINEAGE]==LIN_SC) { fprintf(fp_res,"%f pigment { color rgb CHSV2RGB (<0,%f,1>)}} \n",CZ[i][3],sat); }
	     if (CZ[i][LINEAGE]==LIN_PAN) { fprintf(fp_res,"%f pigment { color rgb CHSV2RGB (<120,%f,1>)}} \n",CZ[i][3],sat); }
	   }
       }
  //  fprintf(fp_res,"plane {<1,0,0>,1 pigment {color rgbf<0,1,0,1>}} \n");
  fclose(fp_res);
};

#if (MUTATE!=MUT_OFF) 
void mutate_fixed(matrixZ CZ,int HZ) {
#  if (MUTATE>=MUT_T_FIXED)
  double zuz=0;	//MUT_STEP==FIXED_VALUE_MIN

#    if (MUT_STEP==FIXED_VALUE_MAX)
  zuz=1;
#    endif

#    if (MUT_STEP==FIXED_VALUE_RAND)
  zuz=zufall(0,1);
#    endif

  int i=MUT_TYPE;

  if (zuz<0.5)
    CZ[HZ][MUT_OFFSET+i+NMUT]=mut_params[i][0][0];
  else
    CZ[HZ][MUT_OFFSET+i+NMUT]=mut_params[i][1][0];

  /*APC mutants require more delta and are more tolerant against contact inhibition*/
  if (i==MUT_APC) {
    //APC flag
    CZ[HZ][MUT_OFFSET+i+NMUT]=mut_params[i][1][0];
    //higher delta
    i=MUT_NOTCH;
    CZ[HZ][MUT_OFFSET+i+NMUT]=mut_params[i][1][0];
    //increase tolerance against contact inhibition
    i=MUT_CONTACTINH;
    CZ[HZ][MUT_OFFSET+i+NMUT]=mut_params[i][1][0];
  }
  get_lineage_mutate_property(CZ,HZ); //update the mutation anyway
#  endif
}
#endif //!MUTATE

/*these methods are independent of the mutation type and necessary in any case*/
void get_lineage_mutate_property(matrixZ CZ,int HZ) {
  int lin=(int) CZ[HZ][LINEAGE];
  int i;
  for (i=0;i<NMUT;++i) {
printf("uid:%f lin:%i i:%i mut pre:%f",CZ[HZ][UID],lin,i,CZ[HZ][MUT_OFFSET+i]);
#if (MUTATE==MUT_OFF)
    /*no mutation occurs, use default value*/
    CZ[HZ][MUT_OFFSET+i]=get_lineage_initial_property(i,lin);
#else //MUTATE==MUT_OFF
#  ifdef MUT_LINEAGE
    /*if lineage of cell do not match, use default value*/
    if (lin!=MUT_LINEAGE)
      CZ[HZ][MUT_OFFSET+i]=get_lineage_initial_property(i,lin);
    else
#  endif //MUT_LINEAGE
      {
        CZ[HZ][MUT_OFFSET+i]=CZ[HZ][MUT_OFFSET+i+NMUT];
      }
#endif //MUTATE==MUT_OFF
printf(" new:%f\n",CZ[HZ][MUT_OFFSET+i]);
  }
}
